#include "windows.h" 
#include "os.h"
#include "texture.h"
#include "time.h"
#include "stdio.h"
#include "string.h"
#include "resource.h"

FILE *gFileLog;

//char gszFullPath[512] = "";
char gszFullPathRoot[512] = "";
//char gszShortFile[128] = "";
char gszShortRoot[128] = "";

char gszPreviewText[512] = "";
char gszAppPath[512] = "";
char gszIniFile[512] = "";

char gszVersion[] = "2.01";

#define DITEM(a) GetDlgItem(hDlg, a)
#define DCHECK(a) IsDlgButtonChecked(hDlg, a)

typedef struct _CONVERT_INFO {
	BOOL	bSeries;
	int		nFrom;
	int		nTo;
	BOOL	bTrim;
	BOOL	bOld;
	ORG_MODE	eMode;
	ORG_POS		eHPos;
	ORG_POS		eVPos;
	int			nHOrg;
	int			nVOrg;
	BOOL		bLoops;
	int			nLoops;
	int			nCelDigits;
	int			nLoopDigits;
} CONVERT_INFO;

CONVERT_INFO ConvertInfo;


void vWriteSettingInt(char *szKey, int nWhat)
{
	char szBuf[50];

	sprintf(szBuf, "%d", nWhat);

	WritePrivateProfileString("Settings", szKey, szBuf, gszIniFile);
}

void vWriteSettingBool(char *szKey, BOOL bWhat)
{
	char szBuf[50];

	if (bWhat) {
		strcpy(szBuf, "True");
	} else {
		strcpy(szBuf, "False");
	}

	WritePrivateProfileString("Settings", szKey, szBuf, gszIniFile);
}

int nReadSettingInt(char *szKey, int nDefault)
{
	return GetPrivateProfileInt("Settings", szKey, nDefault, gszIniFile);
}

BOOL bReadSettingBool(char *szKey, BOOL bDefault)
{
	char szRet[10];

	GetPrivateProfileString("Settings", szKey, "z", szRet, 9, gszIniFile);

	if (szRet[0] == 'z') {
		return bDefault;
	} else if (szRet[0] == 't' || szRet[0] == 'T') {
		return TRUE;
	} else {
		return FALSE;
	}
}

int nLoopDigits(void)
{
	if (ConvertInfo.bLoops) {
		return ConvertInfo.nLoopDigits;
	} else {
		return 0;
	}
}

int nTrimDigits(void)
{
	return nLoopDigits() + ConvertInfo.nCelDigits;
}

int nLoops(void)
{
	if (ConvertInfo.bLoops) {
		return ConvertInfo.nLoops;
	} else {
		return 1;
	}
}

void vWriteIni(void)
{
	vWriteSettingBool("Series", ConvertInfo.bSeries);
	vWriteSettingInt("From", ConvertInfo.nFrom);
	vWriteSettingInt("To", ConvertInfo.nTo);
	vWriteSettingBool("Trim", ConvertInfo.bTrim);
	vWriteSettingBool("Old", ConvertInfo.bOld);
	vWriteSettingBool("BLoops", ConvertInfo.bLoops);
	vWriteSettingInt("OrgMode", ConvertInfo.eMode);
	vWriteSettingInt("OrgPosH", ConvertInfo.eHPos);
	vWriteSettingInt("OrgPosV", ConvertInfo.eVPos);
	vWriteSettingInt("OrgH", ConvertInfo.nHOrg);
	vWriteSettingInt("OrgV", ConvertInfo.nVOrg);
	vWriteSettingInt("NLoops", ConvertInfo.nLoops);
	vWriteSettingInt("CelDigits", ConvertInfo.nCelDigits);
	vWriteSettingInt("LoopDigits", ConvertInfo.nLoopDigits);
}

void vReadIni(void)
{
	ConvertInfo.bSeries = bReadSettingBool("Series", FALSE);
	ConvertInfo.nFrom = nReadSettingInt("From", 1);
	ConvertInfo.nTo = nReadSettingInt("To", 1);
	ConvertInfo.bTrim = bReadSettingBool("Trim", TRUE);
	ConvertInfo.bOld = bReadSettingBool("Old", FALSE);
	ConvertInfo.bLoops = bReadSettingBool("BLoops", FALSE);
	ConvertInfo.eMode = (ORG_MODE)nReadSettingInt("OrgMode", 0);
	ConvertInfo.eHPos = (ORG_POS)nReadSettingInt("OrgPosH", 1);
	ConvertInfo.eVPos = (ORG_POS)nReadSettingInt("OrgPosV", 1);
	ConvertInfo.nHOrg = nReadSettingInt("OrgH", 0);
	ConvertInfo.nVOrg = nReadSettingInt("OrgV", 0);
	ConvertInfo.nLoops = nReadSettingInt("NLoops", 0);
	ConvertInfo.nCelDigits = nReadSettingInt("CelDigits", 4);
	ConvertInfo.nLoopDigits = nReadSettingInt("LoopDigits", 2);
}

void vInitGlobals(void)
{
	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];

	GetModuleFileName(GetModuleHandle(NULL), gszAppPath, 511);

	_splitpath(gszAppPath, szDrive, szDir, NULL, NULL);

	strcpy(gszAppPath, szDrive);
	strcat(gszAppPath, szDir);

	strcpy(gszIniFile, gszAppPath);
	strcat(gszIniFile, "bmp2tex.ini");

	vReadIni();
}


int nGetFrom(HWND hDlg)
{
	char szBuf[50];

	GetDlgItemText(hDlg, IDC_EDIT_FROM, szBuf, 49);

	int nRet = atoi(szBuf);

	if (nRet <= 0) {
		nRet = 1;
	}

	ConvertInfo.nFrom = nRet;

	return nRet;
}

int nGetTo(HWND hDlg)
{
	char szBuf[50];

	GetDlgItemText(hDlg, IDC_EDIT_TO, szBuf, 49);

	int nRet = atoi(szBuf);

	if (nRet <= 0) {
		nRet = -1;
	} else if (nRet < nGetFrom(hDlg)) {
		nRet = nGetFrom(hDlg);
	}

	ConvertInfo.nTo = nRet;

	return nRet;
}

int nGetLoops(HWND hDlg)
{
	char szBuf[50];

	GetDlgItemText(hDlg, IDC_EDIT_LOOPS, szBuf, 49);

	int nRet = atoi(szBuf);

	if (nRet <= 0) {
		nRet = 1;
	}

	ConvertInfo.nLoops = nRet;

	return nRet;
}

int nGetHExact(HWND hDlg)
{
	char szBuf[50];
	int nRet = 0;

	GetDlgItemText(hDlg, IDC_EDIT_HEXACT, szBuf, 49);

	sscanf(szBuf, " %d", &nRet);

	ConvertInfo.nHOrg = nRet;

	return nRet;
}

int nGetVExact(HWND hDlg)
{
	char szBuf[50];
	int nRet = 0;

	GetDlgItemText(hDlg, IDC_EDIT_VEXACT, szBuf, 49);

	sscanf(szBuf, " %d", &nRet);

	ConvertInfo.nVOrg = nRet;

	return nRet;
}

char *szGetOrgInfo(HWND hDlg)
{
	static char szBuf[200];
	BOOL bExact;

	strcpy(szBuf, "Origin will be at ");

	if (!DCHECK(IDC_RADIO_HEXACT) && !DCHECK(IDC_RADIO_VEXACT)) {
		strcat(szBuf, "the ");
		bExact = FALSE;
	} else {
		bExact = TRUE;
	}

	if (bExact) {
		strcat(szBuf, "V:");
	}
	if (DCHECK(IDC_RADIO_VTOP)) {
		strcat(szBuf, "top ");
		ConvertInfo.eVPos = OP_TOP_LEFT;
	} else if (DCHECK(IDC_RADIO_VCENTER)) {
		strcat(szBuf, "center ");
		ConvertInfo.eVPos = OP_CENTER;
	} else if (DCHECK(IDC_RADIO_VBOTTOM)) {
		strcat(szBuf, "bottom ");
		ConvertInfo.eVPos = OP_BOTTOM_RIGHT;
	} else if (DCHECK(IDC_RADIO_VEXACT)) {
		ConvertInfo.eVPos = OP_EXACT;
		ConvertInfo.nVOrg = nGetVExact(hDlg);

		char szNum[10];
		sprintf(szNum, "%d ", ConvertInfo.nVOrg);
		strcat(szBuf, szNum);
	}

	if (bExact) {
		strcat(szBuf, "H:");
	}
	if (DCHECK(IDC_RADIO_HLEFT)) {
		strcat(szBuf, "left ");
		ConvertInfo.eHPos = OP_TOP_LEFT;
	} else if (DCHECK(IDC_RADIO_HCENTER)) {
		if (!DCHECK(IDC_RADIO_VCENTER)) {
			strcat(szBuf, "center ");
		}
		ConvertInfo.eHPos = OP_CENTER;
	} else if (DCHECK(IDC_RADIO_HRIGHT)) {
		strcat(szBuf, "right ");
		ConvertInfo.eHPos = OP_BOTTOM_RIGHT;
	} else if (DCHECK(IDC_RADIO_HEXACT)) {
		ConvertInfo.eHPos = OP_EXACT;
		ConvertInfo.nHOrg = nGetHExact(hDlg);

		char szNum[10];
		sprintf(szNum, "%d ", ConvertInfo.nHOrg);
		strcat(szBuf, szNum);
	}

	if (DCHECK(IDC_RADIO_PRE_TRIM)) {
		ConvertInfo.eMode = OM_PRE_TRIM;

		strcat(szBuf, "of the original bitmap");
	} else {
		ConvertInfo.eMode = OM_POST_TRIM;

		strcat(szBuf, "of the trimmed bitmap");
	}

	if (ConvertInfo.bSeries) {
		strcat(szBuf, "s.");
	} else {
		strcat(szBuf, ".");
	}

	return szBuf;
}

char *szGetPreviewText(HWND hDlg)
{
	char szTempOut[128];

	if (IsDlgButtonChecked(hDlg, IDC_RADIO_SINGLE)) {
		ConvertInfo.bSeries = FALSE;
		ConvertInfo.bLoops = FALSE;

		strcpy(szTempOut, szGetSeriesFileName(gszShortRoot, "tex", 0, 0, 0, 0));
		sprintf(gszPreviewText, "Convert single bitmap %s. Output file is %s. ", 
			szGetSeriesFileName(gszShortRoot, "bmp", 0, 0, 0, 0),
			szTempOut);
	} else {
		ConvertInfo.bSeries = TRUE;
		ConvertInfo.bLoops = DCHECK(IDC_CHECK_LOOPS);
		
		if (ConvertInfo.bLoops) {
			nGetLoops(hDlg);
		}

		char szTo[128];
		char szRootTemp[128];

		int nLen = strlen(gszShortRoot);
		if (nLen > nTrimDigits()) {
			strcpy(szRootTemp, gszShortRoot);
			szRootTemp[nLen - nTrimDigits()] = 0;
		}

		int nTo = nGetTo(hDlg);
		int nFrom = nGetFrom(hDlg);

		if (nTo == -1) {
			strcpy(szTo, "End");
		} else {
			strcpy(szTo, szGetSeriesFileName(szRootTemp, "bmp", ConvertInfo.nCelDigits, nTo, nLoopDigits(), nLoops() - 1));
		}

		strcpy(szTempOut, szGetSeriesFileName(szRootTemp, "tex", 0, 0, 0, 0));

		sprintf(gszPreviewText, "Convert series of bitmaps from %s to %s. Output file is %s. ",
			szGetSeriesFileName(szRootTemp, "bmp", ConvertInfo.nCelDigits, nFrom, nLoopDigits(), 0), 
			szTo,
			szTempOut);
	}


	if (DCHECK(IDC_CHECK_TRIM)) {
		strcat(gszPreviewText, "Trim transparent pixels from the edges. ");
		ConvertInfo.bTrim = TRUE;
	} else {
		strcat(gszPreviewText, "Do not trim transparent pixels from the edges. ");
		ConvertInfo.bTrim = FALSE;
	}

	if (DCHECK(IDC_CHECK_OLD)) {
		strcat(gszPreviewText, "Use the old conversion style. ");
		ConvertInfo.bOld = TRUE;
	} else {
		ConvertInfo.bOld = FALSE;
	}


	strcat(gszPreviewText, szGetOrgInfo(hDlg));

	return gszPreviewText;
}

char *szTrimExt(char *szFile)
{
	int nLen = strlen(szFile);
	int i;

	for (i = nLen - 1; i >= nLen - 4 && i > 0; --i) {
		if (szFile[i] == '.') {
			szFile[i] = 0;
			break;
		}
	}

	return szFile;
}

BOOL bGetFileSpec(void)
{
	OPENFILENAME ofn;

	static char szFilter[] = "BMP Files (*.BMP)\0*.bmp\0\0";

	char szFile[512];
	char szFileTitle[128];

	memset(&ofn, 0, sizeof(OPENFILENAME));

	szFile[0] = 0;
	szFileTitle[0] = 0;

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.lpstrFilter = szFilter;
	ofn.lpstrFile = szFile;
	ofn.nMaxFile = 511;
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = 127;
	ofn.lpstrTitle = "Open BMP (or first in series)";
	ofn.lpstrDefExt = "txt";

	ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;

	BOOL bRet = GetOpenFileName(&ofn);

	if (bRet) {
		strcpy(gszFullPathRoot, szFile);
		strcpy(gszShortRoot, szFileTitle);
		szTrimExt(gszFullPathRoot);
		szTrimExt(gszShortRoot);
	}

	return bRet;
}

void vSetEditInt(HWND hDlg, int nItem, int nWhat)
{
	static char szBuf[17];

	SetDlgItemText(hDlg, nItem, _itoa(nWhat, szBuf, 10));
}

BOOL CALLBACK SpecDialog(HWND hDlg, UINT unMsg, WPARAM wParam, LPARAM lParam)
{
	static BOOL bCalcPreview = TRUE;

	switch (unMsg) {
	case WM_INITDIALOG:

		// we don't want to calculate the preview until all inits are done
		// and some of the inits generate WM_COMMAND messages.
		bCalcPreview = FALSE;
		
		SetDlgItemText(hDlg, IDC_STATIC_VERSION, gszVersion);
		if (ConvertInfo.bSeries) {
			CheckRadioButton(hDlg, IDC_RADIO_SINGLE, IDC_RADIO_SERIES, IDC_RADIO_SERIES);
			EnableWindow(DITEM(IDC_EDIT_FROM), TRUE);
			EnableWindow(DITEM(IDC_EDIT_TO), TRUE);
			EnableWindow(DITEM(IDC_STATIC_FROM), TRUE);
			EnableWindow(DITEM(IDC_STATIC_TO), TRUE);
			EnableWindow(DITEM(IDC_CHECK_LOOPS), TRUE);
			EnableWindow(DITEM(IDC_CHECK_OLD), FALSE);
			vSetEditInt(hDlg, IDC_EDIT_FROM, ConvertInfo.nFrom);
			if (ConvertInfo.nTo != -1) {
				vSetEditInt(hDlg, IDC_EDIT_TO, ConvertInfo.nTo);
			}
			CheckDlgButton(hDlg, IDC_CHECK_LOOPS, ConvertInfo.bLoops);
			if (ConvertInfo.bLoops) {
				EnableWindow(DITEM(IDC_EDIT_LOOPS), TRUE);
				vSetEditInt(hDlg, IDC_EDIT_LOOPS, ConvertInfo.nLoops);
			} else {
				EnableWindow(DITEM(IDC_EDIT_LOOPS), FALSE);
			}
		} else {
			CheckRadioButton(hDlg, IDC_RADIO_SINGLE, IDC_RADIO_SERIES, IDC_RADIO_SINGLE);
			EnableWindow(DITEM(IDC_EDIT_FROM), FALSE);
			EnableWindow(DITEM(IDC_EDIT_TO), FALSE);
			EnableWindow(DITEM(IDC_STATIC_FROM), FALSE);
			EnableWindow(DITEM(IDC_STATIC_TO), FALSE);
			EnableWindow(DITEM(IDC_CHECK_LOOPS), FALSE);
			EnableWindow(DITEM(IDC_EDIT_LOOPS), FALSE);
			EnableWindow(DITEM(IDC_CHECK_OLD), TRUE);
			CheckDlgButton(hDlg, IDC_CHECK_OLD, ConvertInfo.bOld);
		}


		EnableWindow(DITEM(IDC_EDIT_HEXACT), FALSE);
		switch (ConvertInfo.eHPos) {
		case OP_TOP_LEFT:
			CheckRadioButton(hDlg, IDC_RADIO_HLEFT, IDC_RADIO_HEXACT, IDC_RADIO_HLEFT);
			break;
		case OP_CENTER:
			CheckRadioButton(hDlg, IDC_RADIO_HLEFT, IDC_RADIO_HEXACT, IDC_RADIO_HCENTER);
			break;
		case OP_BOTTOM_RIGHT:
			CheckRadioButton(hDlg, IDC_RADIO_HLEFT, IDC_RADIO_HEXACT, IDC_RADIO_HRIGHT);
			break;
		case OP_EXACT:
			CheckRadioButton(hDlg, IDC_RADIO_HLEFT, IDC_RADIO_HEXACT, IDC_RADIO_HEXACT);
			EnableWindow(DITEM(IDC_EDIT_HEXACT), TRUE);
			vSetEditInt(hDlg, IDC_EDIT_HEXACT, ConvertInfo.nHOrg);
			break;
		}

		EnableWindow(DITEM(IDC_EDIT_VEXACT), FALSE);
		switch (ConvertInfo.eVPos) {
		case OP_TOP_LEFT:
			CheckRadioButton(hDlg, IDC_RADIO_VTOP, IDC_RADIO_VEXACT, IDC_RADIO_VTOP);
			break;
		case OP_CENTER:
			CheckRadioButton(hDlg, IDC_RADIO_VTOP, IDC_RADIO_VEXACT, IDC_RADIO_VCENTER);
			break;
		case OP_BOTTOM_RIGHT:
			CheckRadioButton(hDlg, IDC_RADIO_VTOP, IDC_RADIO_VEXACT, IDC_RADIO_VBOTTOM);
			break;
		case OP_EXACT:
			CheckRadioButton(hDlg, IDC_RADIO_VTOP, IDC_RADIO_VEXACT, IDC_RADIO_VEXACT);
			EnableWindow(DITEM(IDC_EDIT_VEXACT), TRUE);
			vSetEditInt(hDlg, IDC_EDIT_VEXACT, ConvertInfo.nVOrg);
			break;
		}

		if (ConvertInfo.eMode == OM_PRE_TRIM) {
			CheckRadioButton(hDlg, IDC_RADIO_PRE_TRIM, IDC_RADIO_POST_TRIM, IDC_RADIO_PRE_TRIM);
		} else {
			CheckRadioButton(hDlg, IDC_RADIO_PRE_TRIM, IDC_RADIO_POST_TRIM, IDC_RADIO_POST_TRIM);
		}

		CheckDlgButton(hDlg, IDC_CHECK_TRIM, ConvertInfo.bTrim);
		if (DCHECK(IDC_CHECK_TRIM)) {
			EnableWindow(DITEM(IDC_RADIO_PRE_TRIM), TRUE);
			EnableWindow(DITEM(IDC_RADIO_POST_TRIM), TRUE);
		} else {
			EnableWindow(DITEM(IDC_RADIO_PRE_TRIM), FALSE);
			EnableWindow(DITEM(IDC_RADIO_POST_TRIM), FALSE);
		}


		SetDlgItemText(hDlg, IDC_STATIC_PREVIEW, szGetPreviewText(hDlg));

		bCalcPreview = TRUE;

		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			case IDCANCEL:
				EndDialog(hDlg, FALSE);
				return TRUE;
			case IDOK:
				EndDialog(hDlg, TRUE);
				return TRUE;

			case IDC_BUTTON_CHANGE:
				bGetFileSpec();
				break;

			case IDC_RADIO_HLEFT:
			case IDC_RADIO_HCENTER:
			case IDC_RADIO_HRIGHT:
				EnableWindow(DITEM(IDC_EDIT_HEXACT), FALSE);
				break;

			case IDC_RADIO_HEXACT:
				EnableWindow(DITEM(IDC_EDIT_HEXACT), TRUE);
				SetFocus(DITEM(IDC_EDIT_HEXACT));
				break;

			case IDC_RADIO_VTOP:
			case IDC_RADIO_VCENTER:
			case IDC_RADIO_VBOTTOM:
				EnableWindow(DITEM(IDC_EDIT_VEXACT), FALSE);
				break;

			case IDC_RADIO_VEXACT:
				EnableWindow(DITEM(IDC_EDIT_VEXACT), TRUE);
				SetFocus(DITEM(IDC_EDIT_VEXACT));
				break;

			case IDC_RADIO_SERIES:
				EnableWindow(DITEM(IDC_EDIT_FROM), TRUE);
				EnableWindow(DITEM(IDC_EDIT_TO), TRUE);
				EnableWindow(DITEM(IDC_STATIC_FROM), TRUE);
				EnableWindow(DITEM(IDC_STATIC_TO), TRUE);
				EnableWindow(DITEM(IDC_CHECK_LOOPS), TRUE);
				EnableWindow(DITEM(IDC_CHECK_OLD), FALSE);
				SetFocus(DITEM(IDC_EDIT_FROM));
				if (DCHECK(IDC_CHECK_LOOPS)) {
					EnableWindow(DITEM(IDC_EDIT_LOOPS), TRUE);
					vSetEditInt(hDlg, IDC_EDIT_LOOPS, ConvertInfo.nLoops);
				} else {
					EnableWindow(DITEM(IDC_EDIT_LOOPS), FALSE);
				}
				break;

			case IDC_RADIO_SINGLE:
				EnableWindow(DITEM(IDC_EDIT_FROM), FALSE);
				EnableWindow(DITEM(IDC_EDIT_TO), FALSE);
				EnableWindow(DITEM(IDC_STATIC_FROM), FALSE);
				EnableWindow(DITEM(IDC_STATIC_TO), FALSE);
				EnableWindow(DITEM(IDC_CHECK_LOOPS), FALSE);
				EnableWindow(DITEM(IDC_EDIT_LOOPS), FALSE);
				EnableWindow(DITEM(IDC_CHECK_OLD), TRUE);
				break;

			case IDC_CHECK_TRIM:
				if (DCHECK(IDC_CHECK_TRIM)) {
					EnableWindow(DITEM(IDC_RADIO_PRE_TRIM), TRUE);
					EnableWindow(DITEM(IDC_RADIO_POST_TRIM), TRUE);
				} else {
					EnableWindow(DITEM(IDC_RADIO_PRE_TRIM), FALSE);
					EnableWindow(DITEM(IDC_RADIO_POST_TRIM), FALSE);
				}
				break;

			case IDC_CHECK_LOOPS:
				if (DCHECK(IDC_CHECK_LOOPS)) {
					EnableWindow(DITEM(IDC_EDIT_LOOPS), TRUE);
					vSetEditInt(hDlg, IDC_EDIT_LOOPS, ConvertInfo.nLoops);
				} else {
					EnableWindow(DITEM(IDC_EDIT_LOOPS), FALSE);
				}
				break;


		}

		if (bCalcPreview) {
			SetDlgItemText(hDlg, IDC_STATIC_PREVIEW, szGetPreviewText(hDlg));
		}
		break;
	}

	return FALSE;
}



//"p:\games\vampwar\user\donm\anconv\A_test" -s 10

//int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdParam, int)
int main( int argc, /* Number of strings in array argv */
 char *argv[],       /* Array of command-line argument strings */
 char **envp )       /* Array of environment variable strings */
{
	char szFilename[512];
	char szInput[512],
	 szOutput[512],
	 szInputAlpha[512];

	int nStartIndex,
	 nEndIndex;

	vInitGlobals();


	gFileLog = fopen("BMP2TEX.LOG", "at");

	vDiagOut("----------------------\n");
	vDiagOut("BMP2TEX Version: %s\n", gszVersion);

	time_t nTime;
	struct tm *pTIME;

	time( &nTime );                 /* Get time in seconds */
	pTIME = localtime( &nTime );  /* Convert time to struct */
										/* tm form */

	/* Print local time as a string */
	vDiagOut("%s\n", asctime(pTIME) );

	if (argc <= 1) {
#if 0
		MessageBox(NULL, 

"Use BMP2TEX like a DOS app, with a command line as follows:\
\n\nBMP2TEX filename [-s [start [end]]]\n\nWhere filename is the name \
(without extension) of the .BMP, .A, and .TEX files. The '.A' file is a \
256-color BMP, and if it is missing, there will be no alpha channel. \
'-s' signals to expect a numbered sequence of BMPs, each file ending \
with four digits starting at 0001. To start/end the sequence differently, \
specify start and end cels. If 'end' is not specified, it will convert \
until it runs out of files. If '-s' is not present, the app will expect \
a single tall, skinny .BMP (and .A) with the cels all the same height \
and width, and separated from each other by a line of alternating black \
and white pixels, starting with black.\n\nA BMP2TEX.LOG file will be \
written to in the current directory, with info on the conversion and \
any errors encountered.\n\nWhen converting series BMPs, excess transparent \
area on the edges of each cel will be trimmed off, and the origin will be \
placed in the center of the original bitmap, before trimming. When converting \
single bitmaps, the transparency will not be trimmed, and the origin will be \
placed in the upper left corner (0,0).\n\nNOTE: In order to filter out stray pixels, \
and working on the assumption that alpha will be calculated to 5-bit \
accuracy, alpha values below 31 are called transparent, and values above \
248 are called opaque.\
\n\nWritten originally by Earl Malmrose, \
Modified by Mark Engelberg and Don Munsil.", 

			"Instructions", MB_ICONINFORMATION | MB_OK);
#endif
		while (bGetFileSpec()) {
			if (!DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_DIALOG_SPEC), NULL, (DLGPROC)SpecDialog)) {
				break;
			}

			vWriteIni();

			vDiagOut("=====\n");
			vDiagOut("%s\n\n", gszPreviewText);


			if (ConvertInfo.bSeries) {
				
				char szFileTemp[512];

				// trim off the last 4 digits.
				int nLen = strlen(gszFullPathRoot);
				if (nLen > nTrimDigits()) {
					strcpy(szFileTemp, gszFullPathRoot);
					szFileTemp[nLen - nTrimDigits()] = 0;
				}

				ConvertSeriesBMPsToTEX(szFileTemp, 
					ConvertInfo.nFrom, 
					ConvertInfo.nTo,
					ConvertInfo.bTrim,
					ConvertInfo.nCelDigits,
					nLoopDigits(),
					nLoops(),
					ConvertInfo.eMode,
					ConvertInfo.eHPos,
					ConvertInfo.eVPos,
					ConvertInfo.nHOrg,
					ConvertInfo.nVOrg);
			} else {
				if (ConvertInfo.bOld) {
					strcpy(szInput, gszFullPathRoot);
					strcat(szInput, ".bmp");

					strcpy(szOutput, gszFullPathRoot);
					strcat(szOutput, ".tex");

					strcpy(szInputAlpha, gszFullPathRoot);
					strcat(szInputAlpha, ".a");

					Convert2BMPsToTEX(szInput, szInputAlpha, szOutput, 0);
				} else {

					// we'll tell it to convert just one
					ConvertSeriesBMPsToTEX(gszFullPathRoot, 
						0, 
						0,
						ConvertInfo.bTrim,
						0, // cel digits
						0, // loop digits
						1, // loops
						ConvertInfo.eMode,
						ConvertInfo.eHPos,
						ConvertInfo.eVPos,
						ConvertInfo.nHOrg,
						ConvertInfo.nVOrg);
				}
			}
		}
	} else {
		vDiagOut("Command line:\n%s\n\n", GetCommandLine());

		/*
		strcpy(cmd1, strtok(lpszCmdParam, " "));
		tempStr = strtok(NULL, " ");
		if (tempStr)
			strcpy(cmd2, tempStr);
		else
			strcpy(cmd2, "");
		tempStr = strtok(NULL, " ");
		if (tempStr)
			strcpy(cmd3, tempStr);
		else
			strcpy(cmd3, "");
		tempStr = strtok(NULL, " ");
		if (tempStr)
			strcpy(cmd4, tempStr);
		else
			strcpy(cmd4, "");
		*/

		strcpy(szFilename, argv[1]);
		strtok(szFilename, ".");

		strcpy(szInput, szFilename);
		strcat(szInput, ".bmp");

		strcpy(szOutput, szFilename);
		strcat(szOutput, ".tex");

		strcpy(szInputAlpha, szFilename);
		strcat(szInputAlpha, ".a");

		if (argc > 2 && !(strcmp(argv[2], "-s"))) {
			// begin series bitmap processing
			if (argc > 3) {
				nStartIndex = atoi(argv[3]);
			} else {
				nStartIndex = 1;
			}

			if (argc > 4) {
				nEndIndex = atoi(argv[4]);
			} else {
				nEndIndex = -1;
			}

			if (nEndIndex == -1) {
				vDiagOut("Converting series '%s' from %d to end.\n", szFilename, nStartIndex);
			} else {
				vDiagOut("Converting series '%s' from %d to %d.\n", szFilename, nStartIndex, nEndIndex);
			}

			ConvertSeriesBMPsToTEX(szFilename, nStartIndex, nEndIndex);
		} else {
			vDiagOut("Converting single bitmap '%s'.\n", szFilename);

			Convert2BMPsToTEX(szInput, szInputAlpha, szOutput, 0);
		}
	}
	if (gFileLog) {
		fclose(gFileLog);
	}
	return 0;
}
