// BUILDING.H	 Things you can go into
//
// DJM

#ifndef _BUILDING_
#define _BUILDING_

#include "drawobj.h"

class MapEditPlane;

class Building : public DrawObj {
	friend class MapEditPlane;
public:
	Building(MapPlane *poPlane, int nTemplateID = 0);
	~Building();

	int nInsideBitmapID(void) {return mpoInsideBitmap ? mpoInsideBitmap->resourceID : 0;}
	void vSetInsideBitmap(int nBitmap);

	Boolean bIsOpen(void) {return mbOpen;}
	Boolean bHasInterior() {return mpoInsideBitmap != NULL;}	//returns T if building has an interior view
	void vSetOpen (Boolean bOpen);
	void vSetForcing(Boolean bForce) {mbForceInterior = bForce;}
	void vChangeToInside(void);
	void vChangeToOutside(void);
	void vCheckState(void);
	Boolean HandleEvent(sciEvent & oEvent);
	MapNode * GetPositionInside();
	MapNode * GetPositionOutside();
	MapNode *poNearestInterior(MapNode *poNode);	//returns an interior node closest to poNode
	
	//map editing mode specific stuff
	void vDrag(sciEvent &oEvent);				// dragging around
	void vSaveBitmap(void);
 	void vCopySelf(sciEvent &oEvent);	//makes copy of self and inserts into node nearest event
	void vInsertSelf(sciEvent &oEvent);	//inserts self into node nearest event

protected:
	Bitmap		*mpoOutsideBitmap;	//the exterior 
	Bitmap		*mpoInsideBitmap;		//the interior (if any)

	Boolean		mbOpen;					// is the building open(can we see the interior)
	Boolean		bLocalPlayerInside(void);//TRUE if a local players unit is inside 
	Boolean		mbForceInterior;		//if TRUE then we can see inside even if no local player is inside
};

#endif