#ifndef _charactr
#define _charactr

#include "sciobj.h"
#include "random.h"

typedef struct
	{
	WORD x;
	WORD y;
	} WPOINT;

class sciProp;
class sciScript;
class ResourceManager;
class sciSound;

class Character : public sciObject
	{
	public:
		Character();
		Character(int newPosition, int newCharacterNumber);
		~Character();
		virtual void DoIWon(sciScript *caller);
		virtual void DoILost(sciScript *caller);
		void ShowCharacter();
		void HideCharacter();
		virtual void SetPosition(int newPosition);
		void SetName(char *newName);
		void StopTalking();

		char *name;
		int characterNumber;
		Boolean facingEast;
		int bodyViewNumber;
		int headViewNumber;
		int habits;
		int numHabits;
		int sleeps;
		int numSleeps;
		int blinks;
		sciProp *head;
		sciProp *body;
		static Random randomGenerator;
		sciSound *sound;

	protected:
		void DoBoth(sciScript *caller, int theBody, int theSync);
		void DoHands(sciScript *caller, int theBody);
		virtual void DoTalking(sciScript *caller, int theSync);

		int position;
		int syncNumber;
		int syncOffset;
		WPOINT headOffset[2];
		ResourceManager *resourceManager;
	};

#endif // _charactr
