#ifndef _dialog
#define _dialog

#include "scimain.h"
#include "scitext.h"
#include "sciplane.h"

#define MAX_INPUT 256		//maximum # of characters for input line


class DialogPlane : public sciPlane {	
public:
	DialogPlane(char *pstrTitleText, char *pstrInputData = NULL, int nNumCharacters = 0);
	~DialogPlane();
	Boolean HandleEvent(sciEvent & oEvent);
	Boolean bValidData() {return mbValidData;}
	Boolean bDone() {return mbDone;}
	void vSetBGColor (BYTE jColor) {vSetBackgroundColor(jColor);}
	void vUpdate();
	void Render(RECT & updateRect);
	void vAutoSize(void);					//automatically size and position self 
protected:
	sciText		*mpoInputLine;
	sciText		*mpoTitleText;
	UINT		mnMaxChars;					//maximum # of characters allowed for input field
	Boolean		mbDone;						//TRUE when exited (ENTER, ESC pressed)
	char		*mpstrData;					//the data string that is returned 
	char		mstrTextBuffer[MAX_INPUT];	//the working character array
	Boolean		mbValidData;				//TRUE if data was entered, FALSE if ESC hit or ENTER with no data

};



#endif