#include "guard.h"

void GuardCoordinator::vAddGuard(Unit *poUnit)
{
	assert(poUnit);
	int i = moGuards.GetSize();
	assert(i < 100);				// TBD - make maStatus dynamic
	moGuards.AddToEnd(poUnit);

	maStatus[i].bValid = FALSE;
	maStatus[i].eStatus = GUARD_NOMESSAGE;
	vDebugOut("Adding Guard\n");
}

int GuardCoordinator::vRemoveGuard(Unit *poUnit)
{
#ifdef _DEBUG
	assert(poUnit);
	assert(moGuards.Find(poUnit) != ID_NONE);  // should always find 
#endif
	moGuards.Remove(poUnit);
	vDebugOut("Removing Guard\n");

	return moGuards.GetSize();
}


void GuardCoordinator::AllGuardsMoveIntoPosition()
{
	vDebugOut("All Guards Move Into Position\n");
	// 
	// DETERMINES BEST FORMATION
	// MAYBE USE STRENGTHS TO DETERMINE FORMATION
	//
	// COMMAND THEM TO MOVEINTOPOSITION FORMATION 
	//
	
	/*
	// WHERE ARE WE GOING?
	Unit * poTargetUnit = moUnitGuarded.poGetAttackee();
	MapNode * poTargetNode = NULL;
	if (poTargetUnit) 
	{
		// get the node from the unit
		poTargetNode = moUnitGuarded.poNode();
	}
	else
	{
		// get the node from the map
		poTargetNode = gpoMap->poGetNode(moUnitGuarded.mnLastTargetX, moUnitGuarded.mnLastTargetY);
	}
	*/

	int nCenterX = moUnitGuarded.nGetX();
	int nCenterY = moUnitGuarded.nGetY();

	int i = moGuards.GetSize();
	int nFormation = F_INDEX[i - 1];
	
	while (i>0)
	{
		i--;

		Unit * pGuard;
		pGuard = moGuards.GetItem(i);

	 
		int x = nCenterX + FORMATIONOFFSETS[  (F_POSITIONS[nFormation + i] - mnDirectionAdjustment * 2) % 48 ];
		int y = nCenterY + FORMATIONOFFSETS[ ((F_POSITIONS[nFormation + i] - mnDirectionAdjustment * 2) % 48 ) + 1 ];

		MapNode * poNode = gpoMap->poGetNode(x, y);
		MapNode * poDest = NULL;
		if (!pGuard->CheckRoute(poNode, &poDest))// ((poNode->meType != TT_CLEAR)||(poNode->mpoUnit))
		{
			int i = 20;
			BOOL bIncrement = x < 20;
			while (i>0)
			{
				i--;
				if (bIncrement)
				{
					x++;
					y++;
				}
				else
				{
					x--;
					y--;
				}
				poNode = gpoMap->poGetNode(x, y);
				if (pGuard->CheckRoute(poNode, &poDest)) 
				{
					break;
				}
			}
		}
		if (poNode) 
		{
			// not a leaf
/*			if (pGuard->IsGuarded())
			{
				Command *poCommand = new Command;
				poCommand->meType = CM_MOVE;
				poCommand->mnX = poNode->mnXPos;
				poCommand->mnY = poNode->mnYPos;
				pGuard->vCommand(*poCommand, TRUE);
			}*/

			Command oCommand;
			oCommand.meType = CM_GUARD_MOVEINTOPOSITION;
			oCommand.mnX = poNode->mnXPos;
			oCommand.mnY = poNode->mnYPos;
			pGuard->vCommand(oCommand, TRUE);
		}
	}
}
 
void GuardCoordinator::Move( MapNode * poMapNodeTarget, BOOL bInterior )
{
	// called by the unit being guarded

	// each guard is requested to move into position and
	mbPreparingToMove = TRUE;
	SetTarget(poMapNodeTarget, bInterior);
	EveryoneMustCheckIn();
	AllGuardsMoveIntoPosition();
	//		can respond GUARD_READY, GUARD_BUSY, GUARD_RESPONDLATER
	// guards that said GUARD_RESPONDLATER move into position
	// once everyone indicates GUARD_READY or GUARD_BUSY, 
	//		movement for those who are READY begins
	// guards move ahead of guarded unit
}

void GuardCoordinator::SetTarget( MapNode * poMapNode, BOOL bInterior )
{
	if (bInterior)
	{
		int nTryX = poMapNode->mnXPos;
		int nTryY = poMapNode->mnYPos;
		int i = 10;
		MapNode * pNode = NULL;
		BOOL bFound = FALSE;
		while (i>0)
		{
			i--;
			nTryX++;
			nTryY++;
			pNode = gpoMap->poGetNode(nTryX, nTryY);
			if (pNode->meType == TT_CLEAR)
			{
				bFound = TRUE;
				break;
			}
		}
		if (bFound)
		{
			mpoMapNodeTarget = pNode;
			mpoMapNodeGuardVerify = poMapNode;
		}
	}
	else
	{
		mpoMapNodeGuardVerify = NULL;
		mpoMapNodeTarget = poMapNode;
	}
	
	// set mnDirectionAdjustment to -6 for every 90 degrees off up
	int nToX, nToY, nFromX, nFromY;

	nToX = mpoMapNodeTarget->mnXPos;
	nToY = mpoMapNodeTarget->mnYPos;

	nFromX = moUnitGuarded.nGetX();
	nFromY = moUnitGuarded.nGetY();

	if (nToX == nFromX)
	{
		if (nToY > nFromY)
		{
			// DOWN
			mnDirectionAdjustment = -12;
		}
		else
		{
			// UP
			mnDirectionAdjustment = 0;
		}
	}
	else if (nToY == nFromY)
	{
		if (nToX > nFromX)
		{
			// RIGHT
			mnDirectionAdjustment = -6;
		}
		else
		{
			// LEFT
			mnDirectionAdjustment = -18;
		}
	}
	else if (nToX > nFromX)
	{
		// TO RIGHT
		if (nToY > nFromY)
		{
			// DOWN
			mnDirectionAdjustment = -9;
		}
		else
		{
			mnDirectionAdjustment = -3;
			// UP
		}
	}
	else   // TO LEFT
	{
		if (nToY > nFromY)
		{
			// DOWN
			mnDirectionAdjustment = -15;
		}
		else
		{
			// UP
			mnDirectionAdjustment = -21;
		}
	}
}
// guards can respond later
void GuardCoordinator::Message(Unit *poFromUnit, enumGuardMessage eGuardMessage)
{
	// called by each of the guards
	// once everyone is either GUARD_BUSY or GUARD_READY
	int i;

	switch (eGuardMessage)
	{
	case GUARD_BUSY:
		vDebugOut("Guard Message GUARD_BUSY\n");
		i = moGuards.Find(poFromUnit);
		assert(i != ID_NONE);  // should always find 
		GuardCheckedIn(i, eGuardMessage);
		if (EveryoneCheckedIn())
		{	
			LinkFormation();
			BeginMoveToTarget();
		}
		break;
	case GUARD_READY:
		vDebugOut("Guard Message GUARD_READY\n");
		i = moGuards.Find(poFromUnit);
		assert(i != ID_NONE);  // should always find 
		GuardCheckedIn(i, eGuardMessage);
		if (EveryoneCheckedIn())
		{	
			LinkFormation();
			BeginMoveToTarget();
		}
		break;
	case GUARD_VERIFIED:
		vDebugOut("Guard Message GUARD_VERIFIED\n");
		if (mpoMapNodeGuardVerify)
		{
			if (mpoUnitPrimary == poFromUnit)
			{
				// move leader to current position
				// move unit to one to right of leader
				Unit::SwapPositions(moUnitGuarded, *mpoUnitPrimary);
			}
		}
		break;
	default:
		assert(0); // message not handled
	}
}

void GuardCoordinator::EveryoneMustCheckIn()
{
	vDebugOut("EveryoneMustCheckIn\n");

	int i = moGuards.GetSize();
	while(i>0)
	{
		i--;
		maStatus[i].bValid = FALSE;
		maStatus[i].eStatus = GUARD_NOMESSAGE;
	}
}

void GuardCoordinator::GuardCheckedIn(int i, enumGuardMessage eGuardMessage)
{
	maStatus[i].bValid = TRUE;
	maStatus[i].eStatus = eGuardMessage;
}

BOOL GuardCoordinator::EveryoneCheckedIn()
{
	int i = moGuards.GetSize();
	while (i>0)
	{
		i--;
		if (FALSE == maStatus[i].bValid)
		{
			return FALSE;
		}
	}
	return TRUE;
}

void GuardCoordinator::LinkFormation()
{
	// link the formation to all units based upon guarded unit position
}

void GuardCoordinator::BeginMoveToTarget()
{
	int i = moGuards.GetSize();
	int nFormation = F_INDEX[i - 1];
	mbPreparingToMove = FALSE;

	Command oCommand;

	while( i > 0 )
	{
		i--;
		Unit * pGuard = moGuards.GetItem(i);

		// send movement to guarded unit to move to designated spot
		oCommand.meType = CM_GUARD_MOVEINTERNAL;
		oCommand.mnX = mpoMapNodeTarget->mnXPos + FORMATIONOFFSETS[  (F_POSITIONS[nFormation + i] - mnDirectionAdjustment * 2) % 48 ]; // + FORMATIONOFFSETS[ F_POSITIONS[nFormation + i] ];
		oCommand.mnY = mpoMapNodeTarget->mnYPos + FORMATIONOFFSETS[ ((F_POSITIONS[nFormation + i] - mnDirectionAdjustment * 2) % 48 ) + 1 ]; //FORMATIONOFFSETS[ F_POSITIONS[nFormation + i] + 1 ];

		if (i == 0) 
		{
			if (mpoMapNodeGuardVerify)
			{
				mpoUnitPrimary = pGuard;
				oCommand.meType = CM_GUARD_MOVETOVERIFY;
				oCommand.mnX = mpoMapNodeGuardVerify->mnXPos;// + FORMATIONOFFSETS[  (F_POSITIONS[nFormation + i] - mnDirectionAdjustment * 2) % 48 ]; // + FORMATIONOFFSETS[ F_POSITIONS[nFormation + i] ];
				oCommand.mnY = mpoMapNodeGuardVerify->mnYPos;// + FORMATIONOFFSETS[ ((F_POSITIONS[nFormation + i] - mnDirectionAdjustment * 2) % 48 ) + 1 ]; //FORMATIONOFFSETS[ F_POSITIONS[nFormation + i] + 1 ];
			}
		}
		pGuard->vCommand(oCommand, TRUE);
	}

	// send movement to guarded unit to move to designated spot
	oCommand.meType = CM_GUARD_MOVEINTERNAL;
	oCommand.mnX = mpoMapNodeTarget->mnXPos;
	oCommand.mnY = mpoMapNodeTarget->mnYPos;
	moUnitGuarded.vCommand(oCommand, TRUE);
}

// private
BOOL GuardCoordinator::GuardsShouldShiftAround()
{
	if (!mbPreparingToMove)
	{
		mnChecksSinceLastShift++;
		if (mnChecksSinceLastShift == mnShiftFrequency)
		{
			mnChecksSinceLastShift = 0;
			return TRUE;
		}
	}
	return FALSE;
}

void GuardCoordinator::Idle()
{
	// this causes guardlike behaviors to happen for the 
	//   Guard Units around the guarded unit.

	// this includes circumnavigation, 
	//		periodic movements outward, 
	//		return to formation position
	if (GuardsShouldShiftAround())
	{
		int i = moGuards.GetSize();
		int nSize = i;
		int nFormation = F_INDEX[i - 1];
		
		int nCenterX = moUnitGuarded.poNode()->mnXPos;
		int nCenterY = moUnitGuarded.poNode()->mnYPos;

		mnRotation += 8;
		if (mnRotation >= 48) mnRotation = 0;

		while (i>0)
		{
			i--;

			Unit * unitGuard = moGuards.GetItem(i);
			Command oCommand;
			oCommand.meType = CM_GUARD_MOVEINTERNAL;

			//int x = nCenterX + 2 * FORMATIONOFFSETS[ F_POSITIONS[nFormation + ((i + mnRotation) % nSize) ] ];
			//int y = nCenterY + 2 * FORMATIONOFFSETS[ F_POSITIONS[nFormation + ((i + mnRotation) % nSize) ] + 1 ];

			int x = nCenterX + 2 * FORMATIONOFFSETS[ (F_POSITIONS[nFormation + i] + mnRotation) % 48];
			int y = nCenterY + 2 * FORMATIONOFFSETS[ (F_POSITIONS[nFormation + i] + mnRotation) % 48 + 1 ];

			oCommand.mnX = x;
			oCommand.mnY = y;
			unitGuard->vCommand(oCommand, TRUE);
		}
	}
}

void GuardCoordinator::FinishMoveToTarget()
{
	// this can be used for more advanced guard functionality

	// when the front guard arrives at designated spot
	// move the guarded unit to his designated spot
	// clear formation
}

void GuardCoordinator::PrepareToHalt()
{}

void GuardCoordinator::CheckingIn()
{}

