// INTPLANE.CPP -- the interface plane
//
// TW

#include "scimain.h"
#include "intplane.h"
#include "portrait.h"
#include "unit.h"
#include "scibuttn.h"
#include "scichkbx.h"
#include "mapscroller.h"
#include "spell.h"
#include "spellpicker.h"
//#include "scibtngp.h"
//#include "intbuttn.h"
//#include "statusln.h"

InterfacePlane *gpoInterface;
extern Boolean gbMapEditing;


InterfacePlane::InterfacePlane()
: sciPlane(pApp->pWindow, FALSE, 500), 
  moAggrL(BTN_ATTR_AGGRESSION,SETTING_LOW), moAggrM(BTN_ATTR_AGGRESSION,SETTING_MEDIUM), moAggrH(BTN_ATTR_AGGRESSION,SETTING_HIGH),
  moTenaL(BTN_ATTR_TENACITY,SETTING_LOW), moTenaM(BTN_ATTR_TENACITY,SETTING_MEDIUM), moTenaH(BTN_ATTR_TENACITY,SETTING_HIGH),

  moMoveCmd(BTN_MOVE), moAttackCmd(BTN_ATTACK), moFeedCmd(BTN_FEED), 
  moVampirize(BTN_CONVERT), moTake(BTN_TAKE), moCastCmd(BTN_CASTSPELL), 
  moGuardCmd(BTN_GUARD), moPatrolCmd(BTN_PATROL), moScoutCmd(BTN_SCOUT),

  moCloakCmd(BTN_CLOAK), moControlCmd(BTN_CNTR_PANEL), moMapZoomCmd(BTN_MAP_ZOOM), moDefAttackCmd(BTN_DEF_ATTACK)
  
{
	mpoHighlightBitmap = NULL;
	mpoPlayer =  game->poLocalPlayer();
	assert(mpoPlayer);
	
	mpoTemplate = (Template*)pApp->pResourceManager->LoadResource(RES_TEMPLATE, mpoPlayer->mpoClan->nInterfaceTemplateNumber());
	assert(mpoTemplate);

	int nPic = mpoTemplate->lGetValue(TAG_Iict, 0);
	int nX = mpoTemplate->lGetValue(TAG_IicX, 0);
	int nY = mpoTemplate->lGetValue(TAG_IicY, 0);

	vSetRect(nX, nY, 640, 480);	
	SetPic(nPic);
	gpoInterface = this; //for now
	mpoSelectionList = NULL;
	mbShowButtons = TRUE;
	mbPortraitShown = FALSE;
	meDisplayArea = DISPLAY_NONE;
	mePortraitMode = PD_BLANK;
	mpoCommandOverlay = NULL;

	//upgrade panel is up by default
	vSetDisplay(DISPLAY_UPGRADES);

	nX = mpoTemplate->lGetValue(TAG_IslX, 0);
	nY = mpoTemplate->lGetValue(TAG_IslY, 0);
	moStatusLine.vSetPlane(this);
	moStatusLine.Posn(nX, nY);
	moStatusLine.Init();
	moStatusLine.SetBackgroundColor(35);
//	moStatusLine.SetText("test");
//	moStatusLine.vSetSize();

	//////////////////////////////
	//							//
	// Setup various portraits	//
	//							//
	//////////////////////////////
	//
	// setup portraits for 3 or more locally selected vampires OR
	// one or more non-locally selected units
	nX = mpoTemplate->lGetValue(TAG_IpoX, 0);
	nY = mpoTemplate->lGetValue(TAG_IpoY, 0);
	int nPortW = mpoTemplate->lGetValue(TAG_IpoW, 0);
	int nPortH = mpoTemplate->lGetValue(TAG_IpoH, 0);
	Portrait::mpoUnitToSummarize = NULL;
	int i;
	for (i = 0; i < MAX_SELECTION_SIZE; ++i) {
		Portrait *poPortrait = new Portrait(this, mpoTemplate);
		poPortrait->vSetUp();
		poPortrait->SetView(4500);
		poPortrait->Init();
		//poPortrait->Posn(PORTRAIT_X + (poPortrait->GetWidth() * (i%3)), PORTRAIT_Y + 1 + (poPortrait->GetHeight() * (i/3) ) );
		poPortrait->Posn(nX + (nPortW * (i%3)), nY + 1 + (nPortH * (i/3) ) );
		poPortrait->SetPri(mnPriority + 50);
		poPortrait->Hide();
		poPortrait->vSetStatusLine(&moStatusLine);
		moPortraits.AddToEnd(poPortrait);
	}
	//
	// setup portrait for SINGLE selected local vampire
	//
	nX = mpoTemplate->lGetValue(TAG_IsoX, 0);
	nY = mpoTemplate->lGetValue(TAG_IsoY, 0);
	//mpoSinglePortrait->Posn(PORTRAIT_X, PORTRAIT_Y);
	mpoSinglePortrait = new SinglePortrait(this, mpoTemplate);
	mpoSinglePortrait->vSetUp();
	int nBG = mpoTemplate->lGetValue(TAG_Ispo, 0);
	mpoSinglePortrait->SetView(nBG);	//set background overlay
	mpoSinglePortrait->Init();
	mpoSinglePortrait->Posn(nX, nY);
	mpoSinglePortrait->SetPri(mnPriority + 50);
	mpoSinglePortrait->Hide();
	mpoSinglePortrait->vSetStatusLine(&moStatusLine);
	//
	// setup portrait for DUAL selected local vampires
	//
	mpoLeftDualPortrait = new DualPortrait(this, mpoTemplate);
	mpoLeftDualPortrait->vSetUp();
	mpoLeftDualPortrait->SetView(4515);
	mpoLeftDualPortrait->Init();
	mpoLeftDualPortrait->Posn(nX, nY);
	mpoLeftDualPortrait->SetPri(mnPriority + 50);
	mpoLeftDualPortrait->Hide();
	mpoLeftDualPortrait->vSetStatusLine(&moStatusLine);
	//
	//now the right
	//
	mpoRightDualPortrait = new DualPortrait(this, mpoTemplate);
	mpoRightDualPortrait->vSetUp();
	mpoRightDualPortrait->SetView(4515);
	mpoRightDualPortrait->Init();
	mpoRightDualPortrait->Posn(nX + mpoLeftDualPortrait->GetWidth(), nY);
	mpoRightDualPortrait->SetPri(mnPriority + 50);
	mpoRightDualPortrait->Hide();
	mpoRightDualPortrait->vSetStatusLine(&moStatusLine);

	vInitAggression();
	vInitTenacity();
	vInitLevel();
	vInitAttack();
	vInitDefend();
	vInitDetect();
	vInitSight();
	vInitSpeed();
	vInitSpells();
	vInitStealth();
	vInitCommandButtons();
	vInitOtherButtons();
	vHideCommandButtons();

	vClearPortraitArray();

	mpoMapScroller = new MapScroller(mnPriority - 10, mpoTemplate);
	mpoMapScroller->vSetStatusLine(&moStatusLine);

	mpoPicker = new SpellPicker(mnPriority + 10, mpoTemplate, &moStatusLine);

	//Initialize and position the overlay
	mpoMapOverlay = new sciView();
	mpoMapOverlay->vSetPlane(this);
	int nID = mpoTemplate->lGetValue(TAG_MMov,0);
	mpoMapOverlay->SetView(nID);
	mpoMapOverlay->Init();
	nX = mpoTemplate->lGetValue(TAG_MMoX,0);
	nY = mpoTemplate->lGetValue(TAG_MMoY,0);
	mpoMapOverlay->Posn(nX,nY);
	mpoMapOverlay->Show();

}

InterfacePlane::~InterfacePlane() {
	if (mpoHighlightBitmap)
	{
		pApp->pResourceManager->FreeResource(mpoHighlightBitmap);
		mpoHighlightBitmap = NULL;
	}

	if (mpoSinglePortrait) {
		delete mpoSinglePortrait;
		mpoSinglePortrait = NULL;
	}

	if (mpoLeftDualPortrait) {
		delete mpoLeftDualPortrait;
		mpoLeftDualPortrait = NULL;
	}

	if (mpoRightDualPortrait) {
		delete mpoRightDualPortrait;
		mpoRightDualPortrait = NULL;
	}
	if (mpoTemplate) {
		pApp->pResourceManager->FreeResource(mpoTemplate);
		mpoTemplate = NULL;
	}
	if (mpoCommandOverlay) {
		delete mpoCommandOverlay;
		mpoCommandOverlay = NULL;
	}


	if(mpoMapOverlay) {
		delete mpoMapOverlay;
		mpoMapOverlay = NULL;
	}

	//no need for delete these here as the window disposes of all planes in its list
	mpoMapScroller = NULL;
	mpoPicker = NULL;

}

void InterfacePlane::Render (RECT &rUpdateRect) {
//	TBD - for now i'm leaving this commented out since I don't have any doco yet as to how
//        how this is to work yet. 
/*	if (Portrait::mpoUnitToSummarize != NULL) {
		vCreateSummaries(Portrait::mpoUnitToSummarize);
	} else {
		moCol1.Hide();
	}
*/
	sciPlane::Render(mrClip);
	//sciPlane::Render(rUpdateRect);
}

void InterfacePlane::Doit() {
	// call the super
	sciPlane::Doit();
}

//Returns the portrait the mouse is over, otherwise returns NULL
Portrait *InterfacePlane::poOnPortrait() {
	switch (mePortraitMode) {
	case PD_LIST:
		{
			int nSize = moPortraits.GetSize();
			int i;
			for (i = 0; i < nSize; ++i) {
				Portrait *poPortrait = moPortraits.GetItem(i);
				if ( poPortrait->OnMe(GetCursorX(), GetCursorY()) ) {
					return poPortrait;
				}
			}
			return NULL;
			break;
		}
	case PD_SINGLE:
		if ( mpoSinglePortrait->OnMe(GetCursorX(), GetCursorY()) ) {
			return (Portrait*)mpoSinglePortrait;
		}
		return NULL;
		break;
	case PD_DUAL:
		if ( mpoLeftDualPortrait->OnMe(GetCursorX(), GetCursorY()) ) {
			return (Portrait*)mpoLeftDualPortrait;
		}
		if ( mpoRightDualPortrait->OnMe(GetCursorX(), GetCursorY()) ) {
			return (Portrait*)mpoRightDualPortrait;
		}
		return NULL;
		break;
	}

	return NULL;
}
	
Boolean InterfacePlane::HandleEvent(sciEvent & oEvent) {
	sciPlane::HandleEvent(oEvent);
	return oEvent.claimed;
}

void InterfacePlane::vSetDisplay(DISPLAY_MODE eMode) { 
	meDisplayArea = eMode; 
	switch (eMode) {
	case DISPLAY_NONE:
		vHideUpgradeButtons();
		break;
	case DISPLAY_UPGRADES:
		if (mbPortraitShown && mbShowButtons) {
			assert(mpoSelectionList);
			vShowUpgradeButtons(mpoSelectionList);	
		}
		break;
	case DISPLAY_SPELLS:
		if (mbPortraitShown && mbShowButtons) {
			vHideUpgradeButtons();
			assert(mpoSelectionList);
		}
		break;
	case DISPLAY_CNTR_PANEL:
		break;
	}
	vMarkUpdate();
}



//refresh button status for a specific vampire
void InterfacePlane::vUpdateVampireBtnState(Vampire *poVampire) {
	if (mbShowButtons) {
		assert(poVampire);
		moAggrGroup.vUpdateButtonState(poVampire);
		moTenaGroup.vUpdateButtonState(poVampire);
		if (meDisplayArea == DISPLAY_UPGRADES) {
			moLevelGroup.vUpdateButtonState(poVampire);
			moAttackGroup.vUpdateButtonState(poVampire);
			moDefendGroup.vUpdateButtonState(poVampire);
			moDetectGroup.vUpdateButtonState(poVampire);
			moSightGroup.vUpdateButtonState(poVampire);
			moSpeedGroup.vUpdateButtonState(poVampire);
			moSpellsGroup.vUpdateButtonState(poVampire);
			moStealthGroup.vUpdateButtonState(poVampire);
		}
		vSetDefaultAttackBitmap((Unit*)poVampire);
	}
}

//This is called when mouse moves off of a portrait and we need to refresh the settings 
//of all upgrade buttons for every selected vampire
//
//refresh button status for all selected vampires
void InterfacePlane::vUpdateSelectedVampires() {
	if (mbShowButtons && mpoSelectionList) {
		moAggrGroup.vUpdateButtonState(mpoSelectionList);
		moTenaGroup.vUpdateButtonState(mpoSelectionList);
		if (meDisplayArea == DISPLAY_UPGRADES) {
			moLevelGroup.vUpdateButtonState(mpoSelectionList);
			moAttackGroup.vUpdateButtonState(mpoSelectionList);
			moDefendGroup.vUpdateButtonState(mpoSelectionList);
			moDetectGroup.vUpdateButtonState(mpoSelectionList);
			moSightGroup.vUpdateButtonState(mpoSelectionList);
			moSpeedGroup.vUpdateButtonState(mpoSelectionList);
			moSpellsGroup.vUpdateButtonState(mpoSelectionList);
			moStealthGroup.vUpdateButtonState(mpoSelectionList);
		}
		vSetDefaultAttackBitmap(mpoSelectionList);
	}
}

//Called from a locally selected unit anytime an Upgrade(aggression or tenacity only) is 
//started/completed
//
//Update changes in aggression and/or tenacity
void InterfacePlane::vUpdateButtonState(ATTR_CODE eAttribute) {
	if (mbShowButtons) {

		//vDebugOut("New attributE\n");
		Portrait *poPortrait = poOnPortrait();
		if (poPortrait == NULL) {
			assert(mpoSelectionList);
			switch (eAttribute) {
			case ATTR_AGGRESSION:
				moAggrGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case ATTR_TENACITY:
				moTenaGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case ATTR_DEFAULT_ATTACK:
				vSetDefaultAttackBitmap(mpoSelectionList);
				break;
			}
		} else {
			//mouse is over a portrait and some upgrade finished for some unit(not necessarily 
			//the one the mouse is over) but we need to update anyway
			vUpdateVampireBtnState((Vampire*)poPortrait->poAssociatedUnit());
		}

	}
}


//Called from a locally selected unit anytime an Upgrade is started/completed
void InterfacePlane::vUpdateButtonState(UPGRADE_NAME eUpgrade) {
	if (mbShowButtons && (meDisplayArea == DISPLAY_UPGRADES) ) {

		//vDebugOut("New attributE\n");
		Portrait *poPortrait = poOnPortrait();
		if (poPortrait == NULL) {
			assert(mpoSelectionList);
			switch (eUpgrade) {
			case UPGRADE_Sight:
				moSightGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case UPGRADE_Attack:
				moAttackGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case UPGRADE_Defend:
				moDefendGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case UPGRADE_Speed:
				moSpeedGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case UPGRADE_Stealth:
				moStealthGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case UPGRADE_Detection:
				moDetectGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case UPGRADE_Spells:
				moSpellsGroup.vUpdateButtonState(mpoSelectionList);
				break;
			case UPGRADE_Level:
				moLevelGroup.vUpdateButtonState(mpoSelectionList);
				break;
			}
		} else {
			//mouse is over a portrait and some upgrade finished for some unit(not necessarily 
			//the one the mouse is over) but we need to update anyway
			vUpdateVampireBtnState((Vampire*)poPortrait->poAssociatedUnit());
		}

	}
}

void InterfacePlane::vGetPortraitMode (RefList<DrawObj> *poUnitList) {
	int nSize;
	nSize = poUnitList->GetSize();
	switch (nSize) {
	case 0:
		{
			mePortraitMode = PD_BLANK;
			break;
		}
	case 1:
		{
			Unit *poUnit = (Unit*)poUnitList->GetItem(0);
			if (poUnit->bIsLocalVampire() == TRUE) {
				mePortraitMode = PD_SINGLE;
			} else {
				mePortraitMode = PD_LIST;
			}
			break;
		}
	case 2:
//they said we'll never use dual portraits, but lets wait a little while longer
/*		{
			Unit *poUnit1 = (Unit*)poUnitList->GetItem(0);
			Unit *poUnit2 = (Unit*)poUnitList->GetItem(1);
			if ( (poUnit1->bIsLocalVampire() == TRUE) && (poUnit2->bIsLocalVampire() == TRUE) ) {
				mePortraitMode = PD_DUAL;
			} else {
				mePortraitMode = PD_LIST;
			}
			break;
		}
*/	default:	//3 or more
		{
			mePortraitMode = PD_LIST;
			break;
		}
	
	}
}


void InterfacePlane::vRefreshInventory()
{
	switch (mePortraitMode)
	{
	case PD_BLANK:
		break;	//this should never happen
	case PD_LIST:
		break;	//don't display anything
	case PD_SINGLE:
		mpoSinglePortrait->vRefreshInventory();
		break;
	case PD_DUAL:
		mpoLeftDualPortrait->vRefreshInventory();
		mpoRightDualPortrait->vRefreshInventory();
		break;
	}
}


void InterfacePlane::vShowPortraits(RefList<DrawObj> *poUnitList) {
	if (gbMapEditing == FALSE) {

		mpoSelectionList = poUnitList;
		
		vGetPortraitMode(poUnitList);
//		vDebugOut ("mode: %d\n", mePortraitMode);
		
		switch (mePortraitMode) {
		case PD_BLANK:
			mbShowButtons = FALSE;
			vHidePortraits();
			vClearPortraitArray();
			break;
		case PD_LIST:
			//we need to display 3 or more portraits
			{
				mbPortraitShown = TRUE;
				int nSize, i;
				nSize = poUnitList->GetSize();
				mbShowButtons = TRUE; //assume T unless someone isn't a local vampire
				for (i = 0; i < nSize; ++i) {
					Unit *poUnit = (Unit*)poUnitList->GetItem(i);
					int nNdx = nArrayIndex((DrawObj*)poUnit);
					assert (nNdx != -1);

					Portrait *poPortrait = moPortraits.GetItem(nNdx);
//					poPortrait->SetView(poUnit->lBitmapPortrait());
					
					if (mapoPortraitArray[nNdx] != NULL) {
						poPortrait->Show((Unit*)mapoPortraitArray[nNdx]);
					}
					//poPortrait->Show(poUnit)

					//look for a reason NOT to show the buttons(any non local vampire) 
					if (mbShowButtons) {
						//always assume we can show buttons until the 1st instance where we
						//don't have a local vampire, then anytime after that, we won't show buttons
						mbShowButtons = poUnit->bIsLocalVampire();
					}

				}

				if (mbShowButtons) {
					vShowUpgradeButtons(poUnitList);
					vShowCommandButtons();
				}
				
				break;
			}
		case PD_SINGLE:
			//we need to display a single portrait
			{
				vClearPortraitArray();
				mbPortraitShown = TRUE;
				mbShowButtons = TRUE;
				Unit *poUnit = (Unit*)poUnitList->GetItem(0);
				mapoPortraitArray[0] = (DrawObj*)poUnit;
				assert(mpoSinglePortrait);
				mpoSinglePortrait->Show(poUnit);
				vShowUpgradeButtons(poUnitList);
				vShowCommandButtons();
				break;
			}
		case PD_DUAL:
			//we need to display dual portraits
			{
				vClearPortraitArray();
				mbShowButtons = TRUE;
				mbPortraitShown = TRUE;
				Unit *poUnit1 = (Unit*)poUnitList->GetItem(0);
				Unit *poUnit2 = (Unit*)poUnitList->GetItem(1);
				mapoPortraitArray[0] = (DrawObj*)poUnit1;
				mapoPortraitArray[1] = (DrawObj*)poUnit2;
				assert(mpoLeftDualPortrait);
				assert(mpoRightDualPortrait);
				mpoLeftDualPortrait->Show(poUnit1);
				mpoRightDualPortrait->Show(poUnit2);
				vShowUpgradeButtons(poUnitList);
				vShowCommandButtons();
				break;
			}
		}
		
		vMarkUpdate();

	} //gbMapEditing == FALSE

}

void InterfacePlane::vHidePortraits() {
	if (gbMapEditing == FALSE) {
		
		mbPortraitShown = FALSE;
		Portrait::mpoUnitToSummarize = NULL; //this will force the hiding of the summaries
		mpoSelectionList = NULL;
		moStatusLine.Hide();
		vHideUpgradeButtons();
		vHideCommandButtons();

		switch (mePortraitMode) {
		case PD_BLANK:
			break;
		case PD_LIST:
			{
				int i;
				for (i = 0; i < MAX_SELECTION_SIZE; ++i) {
					Portrait *poPortrait = moPortraits.GetItem(i);
					poPortrait->Hide();
				}
				break;
			}
		case PD_SINGLE:
			mpoSinglePortrait->Hide();
			break;
		case PD_DUAL:
			mpoLeftDualPortrait->Hide();
			mpoRightDualPortrait->Hide();
			break;
		}
		
		mePortraitMode = PD_BLANK;

	} //gbMapEditing == FALSE

}



void InterfacePlane::vInitAggression() {
	moAggrL.vSetPlane(this);
	moAggrL.vSetText("L ");
	moAggrL.vSetTextSize();
	moAggrL.SetWidth(moAggrL.nTextWidth());
	moAggrL.SetHeight(moAggrL.nTextHeight() );
//	moAggrL.Posn(AGGR_L_X, AGGR_Y);
//	moAggrL.vSetHotkey('a');
	moAggrL.Init();

	moAggrM.vSetPlane(this);
	moAggrM.vSetText("M");
	moAggrM.vSetTextSize();
	moAggrM.SetWidth(moAggrM.nTextWidth());
	moAggrM.SetHeight(moAggrM.nTextHeight() );
//	moAggrM.Posn(AGGR_M_X,AGGR_Y);
//	moAggrM.SetPri(mnPriority + 100);
//	moAggrM.SetHotkey('s');
	moAggrM.Init();

	moAggrH.vSetPlane(this);
	moAggrH.vSetText("H");
	moAggrH.vSetTextSize();
	moAggrH.SetWidth(moAggrH.nTextWidth());
	moAggrH.SetHeight(moAggrH.nTextHeight() );
//	moAggrH.Posn(AGGR_H_X,AGGR_Y);
//	moAggrH.SetPri(mnPriority + 100);
//	moAggrH.SetHotkey('s');
	moAggrH.Init();

	moAggrGroup.vSetStatusLine(&moStatusLine);
	moAggrGroup.vSetPlane(this);
	moAggrGroup.Init();
	moAggrGroup.SetPri(10);
	moAggrGroup.vAddToGroup(&moAggrL);
	moAggrGroup.vAddToGroup(&moAggrM);
	moAggrGroup.vAddToGroup(&moAggrH);
	moAggrGroup.vSetStatusText("Aggression");
	moAggrGroup.vSetIconText("Ag:");
	int nX = mpoTemplate->lGetValue(TAG_IagX,0);
	int nY = mpoTemplate->lGetValue(TAG_IagY,0);
//	moAggrGroup.mpoIconText->Posn(AGGR_ICON_X,AGGR_Y);
	moAggrGroup.Posn(nX,nY);
	moAggrGroup.mpoIconText->Init();
//	moAggrGroup.vSetIconView(5001);
//	moAggrGroup.mpoIconView->Init();
//	moAggrGroup.mpoIconView->Posn(AGGR_ICON_X, AGGR_Y);
	moAggrGroup.Hide();
	moAggrGroup.vSetGroupRect();

}

void InterfacePlane::vInitTenacity() {
	moTenaL.vSetPlane(this);
	moTenaL.vSetText("L ");
	moTenaL.vSetTextSize();
	moTenaL.SetWidth(moTenaL.nTextWidth());
	moTenaL.SetHeight(moTenaL.nTextHeight() );
//	moTenaL.Posn(TENA_L_X, TENA_Y);
	moTenaL.Init();

	moTenaM.vSetPlane(this);
	moTenaM.vSetText("M");
	moTenaM.vSetTextSize();
	moTenaM.SetWidth(moTenaM.nTextWidth());
	moTenaM.SetHeight(moTenaM.nTextHeight() );
//	moTenaM.Posn(TENA_M_X,TENA_Y);
	moTenaM.Init();

	moTenaH.vSetPlane(this);
	moTenaH.vSetText("H");
	moTenaH.vSetTextSize();
	moTenaH.SetWidth(moTenaH.nTextWidth());
	moTenaH.SetHeight(moTenaH.nTextHeight() );
//	moTenaH.Posn(TENA_H_X,TENA_Y);
	moTenaH.Init();
	
	moTenaGroup.vSetStatusLine(&moStatusLine);
	moTenaGroup.vSetPlane(this);
	moTenaGroup.Init();
	moTenaGroup.SetPri(10);
	moTenaGroup.vAddToGroup(&moTenaL);
	moTenaGroup.vAddToGroup(&moTenaM);
	moTenaGroup.vAddToGroup(&moTenaH);
	moTenaGroup.vSetStatusText("Tenacity");
	moTenaGroup.vSetIconText("Te:");
	int nX = mpoTemplate->lGetValue(TAG_IteX,0);
	int nY = mpoTemplate->lGetValue(TAG_IteY,0);
	moTenaGroup.Posn(nX, nY);
	moTenaGroup.mpoIconText->Init();
	moTenaGroup.Hide();
	moTenaGroup.vSetGroupRect();
}

void InterfacePlane::vInitLevel()
{
	char cText[2]; //for text labels only

	moLevelGroup.vSetStatusLine(&moStatusLine);
	moLevelGroup.vSetPlane(this);
	moLevelGroup.Init();
	moLevelGroup.SetPri(10);
	for (int i=0; i < MAX_LEVEL_UPGRADE; ++i)
	{
		AttributeButton *poBtn = new AttributeButton(BTN_ATTR_LEVEL, i+1);
		poBtn->vSetPlane(this);
		sprintf (cText, "%d", i+1);
		poBtn->vSetText(cText);
		poBtn->vSetTextSize();
		poBtn->SetWidth(poBtn->nTextWidth());
		poBtn->SetHeight(poBtn->nTextHeight() );
//		poBtn->Posn(LEVEL_5_X, LEVEL_Y);
		poBtn->Init();
		moLevelGroup.vAddToGroup(poBtn);
		moLevelButtons.AddToEnd(poBtn);
	}

	moLevelGroup.vSetStatusText("Level");
	moLevelGroup.vSetIconText("Le:");
	int nX = mpoTemplate->lGetValue(TAG_IleX,0);
	int nY = mpoTemplate->lGetValue(TAG_IleY,0);
//	moLevelGroup.mpoIconText->Posn(nX, nY);
	moLevelGroup.Posn(nX, nY);
	moLevelGroup.mpoIconText->Init();
	moLevelGroup.Hide();
	moLevelGroup.vSetGroupRect();

	
}

void InterfacePlane::vInitAttack() {
	char cText[2]; //for text labels only
	int nX,nY;

	moAttackGroup.vSetStatusLine(&moStatusLine);
	moAttackGroup.vSetPlane(this);
	moAttackGroup.Init();
	moAttackGroup.SetPri(10);
	for (int i=0; i <= MAX_UPGRADES_UPGRADE; ++i)
	{
		AttributeButton *poBtn = new AttributeButton(BTN_ATTR_ATTACK, i);
		poBtn->vSetPlane(this);
		sprintf (cText, "%d", i);
		poBtn->vSetText(cText);
		poBtn->vSetTextSize();
		poBtn->SetWidth(poBtn->nTextWidth());
		poBtn->SetHeight(poBtn->nTextHeight() );
		poBtn->Init();
		moAttackGroup.vAddToGroup(poBtn);
		moAttackButtons.AddToEnd(poBtn);
	}

	moAttackGroup.vSetStatusText("Attack");
	moAttackGroup.vSetIconText("At:");
	vButtonStartCoords(UPGRADE_Attack,nX,nY);
	moAttackGroup.Posn(nX, nY);
	moAttackGroup.mpoIconText->Init();
	moAttackGroup.Hide();
	moAttackGroup.vSetGroupRect();
	
/*	
	moAttack0.vSetPlane(this);
	moAttack0.vSetText("0");
	moAttack0.vSetTextSize();
	moAttack0.SetWidth(moAttack0.nTextWidth());
	moAttack0.SetHeight(moAttack0.nTextHeight() );
	moAttack0.Posn(ATTACK_0_X, ATTACK_Y);
	moAttack0.Init();

	moAttack1.vSetPlane(this);
	moAttack1.vSetText("1");
	moAttack1.vSetTextSize();
	moAttack1.SetWidth(moAttack1.nTextWidth());
	moAttack1.SetHeight(moAttack1.nTextHeight() );
	moAttack1.Posn(ATTACK_1_X, ATTACK_Y);
	moAttack1.Init();

	moAttack2.vSetPlane(this);
	moAttack2.vSetText("2");
	moAttack2.vSetTextSize();
	moAttack2.SetWidth(moAttack2.nTextWidth());
	moAttack2.SetHeight(moAttack2.nTextHeight() );
	moAttack2.Posn(ATTACK_2_X, ATTACK_Y);
	moAttack2.Init();

	moAttackGroup.vSetStatusLine(&moStatusLine);
	moAttackGroup.vSetPlane(this);
	moAttackGroup.Init();
	moAttackGroup.vAddToGroup(&moAttack0);
	moAttackGroup.vAddToGroup(&moAttack1);
	moAttackGroup.vAddToGroup(&moAttack2);
	moAttackGroup.vSetStatusText("Attack");
	moAttackGroup.vSetIconText("At:");
	moAttackGroup.mpoIconText->Posn(ATTACK_ICON_X,ATTACK_Y);
	moAttackGroup.mpoIconText->Init();
	moAttackGroup.vSetGroupRect();
	moAttackGroup.Hide();
*/
}

void InterfacePlane::vInitDefend() {
	char cText[2]; //for text labels only
	int nX,nY;

	moDefendGroup.vSetStatusLine(&moStatusLine);
	moDefendGroup.vSetPlane(this);
	moDefendGroup.Init();
	moDefendGroup.SetPri(10);
	for (int i=0; i <= MAX_UPGRADES_UPGRADE; ++i)
	{
		AttributeButton *poBtn = new AttributeButton(BTN_ATTR_DEFEND, i);
		poBtn->vSetPlane(this);
		sprintf (cText, "%d", i);
		poBtn->vSetText(cText);
		poBtn->vSetTextSize();
		poBtn->SetWidth(poBtn->nTextWidth());
		poBtn->SetHeight(poBtn->nTextHeight() );
		poBtn->Init();
		moDefendGroup.vAddToGroup(poBtn);
		moDefendButtons.AddToEnd(poBtn);
	}

	moDefendGroup.vSetStatusText("Defend");
	moDefendGroup.vSetIconText("Df:");
	vButtonStartCoords(UPGRADE_Defend,nX,nY);
	moDefendGroup.Posn(nX, nY);
	moDefendGroup.mpoIconText->Init();
	moDefendGroup.Hide();
	moDefendGroup.vSetGroupRect();
}

void InterfacePlane::vInitDetect() {
	char cText[2]; //for text labels only
	int nX,nY;

	moDetectGroup.vSetStatusLine(&moStatusLine);
	moDetectGroup.vSetPlane(this);
	moDetectGroup.Init();
	moDetectGroup.SetPri(10);
	for (int i=0; i <= MAX_UPGRADES_UPGRADE; ++i)
	{
		AttributeButton *poBtn = new AttributeButton(BTN_ATTR_DETECTION, i);
		poBtn->vSetPlane(this);
		sprintf (cText, "%d", i);
		poBtn->vSetText(cText);
		poBtn->vSetTextSize();
		poBtn->SetWidth(poBtn->nTextWidth());
		poBtn->SetHeight(poBtn->nTextHeight() );
		poBtn->Init();
		moDetectGroup.vAddToGroup(poBtn);
		moDetectButtons.AddToEnd(poBtn);
	}

	moDetectGroup.vSetStatusText("Detect");
	moDetectGroup.vSetIconText("Dt:");
	vButtonStartCoords(UPGRADE_Detection,nX,nY);
	moDetectGroup.Posn(nX, nY);
	moDetectGroup.mpoIconText->Init();
	moDetectGroup.Hide();
	moDetectGroup.vSetGroupRect();
}

void InterfacePlane::vInitSight() {
	char cText[2]; //for text labels only
	int nX,nY;

	moSightGroup.vSetStatusLine(&moStatusLine);
	moSightGroup.vSetPlane(this);
	moSightGroup.Init();
	moSightGroup.SetPri(10);
	for (int i=0; i <= MAX_UPGRADES_UPGRADE; ++i)
	{
		AttributeButton *poBtn = new AttributeButton(BTN_ATTR_SIGHT, i);
		poBtn->vSetPlane(this);
		sprintf (cText, "%d", i);
		poBtn->vSetText(cText);
		poBtn->vSetTextSize();
		poBtn->SetWidth(poBtn->nTextWidth());
		poBtn->SetHeight(poBtn->nTextHeight() );
		poBtn->Init();
		moSightGroup.vAddToGroup(poBtn);
		moSightButtons.AddToEnd(poBtn);
	}

	moSightGroup.vSetStatusText("Sight");
	moSightGroup.vSetIconText("Si:");
	vButtonStartCoords(UPGRADE_Sight,nX,nY);
	moSightGroup.Posn(nX, nY);
	moSightGroup.mpoIconText->Init();
	moSightGroup.Hide();
	moSightGroup.vSetGroupRect();
}

void InterfacePlane::vInitSpeed() {
	char cText[2]; //for text labels only
	int nX,nY;

	moSpeedGroup.vSetStatusLine(&moStatusLine);
	moSpeedGroup.vSetPlane(this);
	moSpeedGroup.Init();
	moSpeedGroup.SetPri(10);
	for (int i=0; i <= MAX_UPGRADES_UPGRADE; ++i)
	{
		AttributeButton *poBtn = new AttributeButton(BTN_ATTR_SPEED, i);
		poBtn->vSetPlane(this);
		sprintf (cText, "%d", i);
		poBtn->vSetText(cText);
		poBtn->vSetTextSize();
		poBtn->SetWidth(poBtn->nTextWidth());
		poBtn->SetHeight(poBtn->nTextHeight() );
		poBtn->Init();
		moSpeedGroup.vAddToGroup(poBtn);
		moSpeedButtons.AddToEnd(poBtn);
	}

	moSpeedGroup.vSetStatusText("Speed");
	moSpeedGroup.vSetIconText("Sp:");
	vButtonStartCoords(UPGRADE_Speed,nX,nY);
	moSpeedGroup.Posn(nX, nY);
	moSpeedGroup.mpoIconText->Init();
	moSpeedGroup.Hide();
	moSpeedGroup.vSetGroupRect();
}

void InterfacePlane::vInitSpells() {
	char cText[2]; //for text labels only
	int nX,nY;

	moSpellsGroup.vSetStatusLine(&moStatusLine);
	moSpellsGroup.vSetPlane(this);
	moSpellsGroup.Init();
	moSpellsGroup.SetPri(10);
	for (int i=0; i <= MAX_UPGRADES_UPGRADE; ++i)
	{
		AttributeButton *poBtn = new AttributeButton(BTN_ATTR_SPELLS, i);
		poBtn->vSetPlane(this);
		sprintf (cText, "%d", i);
		poBtn->vSetText(cText);
		poBtn->vSetTextSize();
		poBtn->SetWidth(poBtn->nTextWidth());
		poBtn->SetHeight(poBtn->nTextHeight() );
		poBtn->Init();
		moSpellsGroup.vAddToGroup(poBtn);
		moSpellsButtons.AddToEnd(poBtn);
	}

	moSpellsGroup.vSetStatusText("Spells");
	moSpellsGroup.vSetIconText("Sl:");
	vButtonStartCoords(UPGRADE_Spells,nX,nY);
	moSpellsGroup.Posn(nX, nY);
	moSpellsGroup.mpoIconText->Init();
	moSpellsGroup.Hide();
	moSpellsGroup.vSetGroupRect();
}

void InterfacePlane::vInitStealth() {
	char cText[2]; //for text labels only
	int nX,nY;

	moStealthGroup.vSetStatusLine(&moStatusLine);
	moStealthGroup.vSetPlane(this);
	moStealthGroup.Init();
	moStealthGroup.SetPri(10);
	for (int i=0; i <= MAX_UPGRADES_UPGRADE; ++i)
	{
		AttributeButton *poBtn = new AttributeButton(BTN_ATTR_STEALTH, i);
		poBtn->vSetPlane(this);
		sprintf (cText, "%d", i);
		poBtn->vSetText(cText);
		poBtn->vSetTextSize();
		poBtn->SetWidth(poBtn->nTextWidth());
		poBtn->SetHeight(poBtn->nTextHeight() );
		poBtn->Init();
		moStealthGroup.vAddToGroup(poBtn);
		moStealthButtons.AddToEnd(poBtn);
	}

	moStealthGroup.vSetStatusText("Stealth");
	moStealthGroup.vSetIconText("St:");
	vButtonStartCoords(UPGRADE_Stealth,nX,nY);
	moStealthGroup.Posn(nX, nY);
	moStealthGroup.mpoIconText->Init();
	moStealthGroup.Hide();
	moStealthGroup.vSetGroupRect();
}



// Hide all related buttons and button groups
void InterfacePlane::vHideUpgradeButtons() {
	moLevelGroup.Hide();
	moAttackGroup.Hide();
	moDefendGroup.Hide();
	moDetectGroup.Hide();
	moSightGroup.Hide();
	moSpeedGroup.Hide();
	moSpellsGroup.Hide();
	moStealthGroup.Hide();
	moAggrGroup.Hide();
	moTenaGroup.Hide();
	moCloakCmd.Hide();
	moDefAttackCmd.Hide();
}

// Show all related buttons and button groups
void InterfacePlane::vShowUpgradeButtons(RefList<DrawObj> *poUnitList) {
	if (poUnitList == NULL) {
		return;
	}

	if (meDisplayArea == DISPLAY_UPGRADES) {
		int nX,nY;

		moLevelGroup.Show();
		moLevelGroup.vUpdateButtonState(poUnitList);
		
		//Attack
		if (mpoPlayer->manUpgradeLevel[UPGRADE_Attack] != 0)
		{
			vButtonStartCoords(UPGRADE_Attack,nX,nY);
			moAttackGroup.Posn(nX, nY);
			moAttackGroup.Show();
			moAttackGroup.vSetGroupRect();
			moAttackGroup.vUpdateButtonState(poUnitList);	//update button group for all selections and set selction list for button(poUnitLIst)
		}

		//Defend
		if (mpoPlayer->manUpgradeLevel[UPGRADE_Defend] != 0)
		{
			vButtonStartCoords(UPGRADE_Defend,nX,nY);
			moDefendGroup.Posn(nX, nY);
			moDefendGroup.Show();
			moDefendGroup.vSetGroupRect();
			moDefendGroup.vUpdateButtonState(poUnitList);
		}

		//Detection
		if (mpoPlayer->manUpgradeLevel[UPGRADE_Detection] != 0)
		{
			vButtonStartCoords(UPGRADE_Detection,nX,nY);
			moDetectGroup.Posn(nX, nY);
			moDetectGroup.Show();
			moDetectGroup.vSetGroupRect();
			moDetectGroup.vUpdateButtonState(poUnitList);
		}

		//Sight
		if (mpoPlayer->manUpgradeLevel[UPGRADE_Sight] != 0)
		{
			vButtonStartCoords(UPGRADE_Sight,nX,nY);
			moSightGroup.Posn(nX, nY);
			moSightGroup.Show();
			moSightGroup.vSetGroupRect();
			moSightGroup.vUpdateButtonState(poUnitList);
		}

		//Speed
		if (mpoPlayer->manUpgradeLevel[UPGRADE_Speed] != 0)
		{
			vButtonStartCoords(UPGRADE_Speed,nX,nY);
			moSpeedGroup.Posn(nX, nY);
			moSpeedGroup.Show();
			moSpeedGroup.vSetGroupRect();
			moSpeedGroup.vUpdateButtonState(poUnitList);
		}

		//Spells
		if (mpoPlayer->manUpgradeLevel[UPGRADE_Spells] != 0)
		{
			vButtonStartCoords(UPGRADE_Spells,nX,nY);
			moSpellsGroup.Posn(nX, nY);
			moSpellsGroup.Show();
			moSpellsGroup.vSetGroupRect();
			moSpellsGroup.vUpdateButtonState(poUnitList);
		}

		//Stealth
		if (mpoPlayer->manUpgradeLevel[UPGRADE_Stealth] != 0)
		{
			vButtonStartCoords(UPGRADE_Stealth,nX,nY);
			moStealthGroup.Posn(nX, nY);
			moStealthGroup.Show();
			moStealthGroup.vSetGroupRect();
			moStealthGroup.vUpdateButtonState(poUnitList);
		}

		moAggrGroup.Show();
		moTenaGroup.Show();
		//update button group for all selections and set selction list for buttons(poUnitLIst)
		moAggrGroup.vUpdateButtonState(poUnitList);
		moTenaGroup.vUpdateButtonState(poUnitList);

		moCloakCmd.Show();
		vSetDefaultAttackBitmap(poUnitList);
		moDefAttackCmd.Show();

		//if mouse is over specific portrait, update buttons just for that one
		Portrait *poPortrait = poOnPortrait();
		if (poPortrait != NULL ) {
			vUpdateVampireBtnState((Vampire*)poPortrait->poAssociatedUnit());
		}

	}

}

void InterfacePlane::vShowCommandButtons() {
	moMoveCmd.Show();
	moAttackCmd.Show();
	moFeedCmd.Show();
	moVampirize.Show();
	moTake.Show();
	moCastCmd.Show();
	moGuardCmd.Show();
	moPatrolCmd.Show();
	moScoutCmd.Show();
	if (mpoCommandOverlay)
		mpoCommandOverlay->Show();
}

void InterfacePlane::vHideCommandButtons() {
	moMoveCmd.Hide();
	moAttackCmd.Hide();
	moFeedCmd.Hide();
	moVampirize.Hide();
	moTake.Hide();
	moCastCmd.Hide();
	moGuardCmd.Hide();
	moPatrolCmd.Hide();
	moScoutCmd.Hide();
	if (mpoCommandOverlay)
		mpoCommandOverlay->Hide();
}



void InterfacePlane::vInitCommandButtons() {
	int nX, nY, nBitmapID;

	int nResID = mpoTemplate->lGetValue(TAG_Icbo,0);
	nX = mpoTemplate->lGetValue(TAG_IcbX,0);
	nY = mpoTemplate->lGetValue(TAG_IcbY,0);
	mpoCommandOverlay = new sciView();
	mpoCommandOverlay->vSetPlane(this);
	mpoCommandOverlay->SetView(nResID);
	mpoCommandOverlay->Init();
	mpoCommandOverlay->Posn(nX,nY);
	mpoCommandOverlay->SetPri(1);
	mpoCommandOverlay->Hide();


	nX = mpoTemplate->lGetValue(TAG_ImoX, 0);
	nY = mpoTemplate->lGetValue(TAG_ImoY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCmo, 0);
	moMoveCmd.vSetPlane(this);
//	moMoveCmd.SetFont(2,3,4,5);
//	moMoveCmd.SetText("Move");
//	moMoveCmd.vSetTextSize();
//	moMoveCmd.SetWidth(moMoveCmd.nTextWidth());
//	moMoveCmd.SetHeight(moMoveCmd.nTextHeight() );
	moMoveCmd.SetPri(mnPriority + 100);
	moMoveCmd.SetView(nBitmapID);
	moMoveCmd.SetHotkey('m');
	moMoveCmd.vSetStatusLine(&moStatusLine);
	moMoveCmd.vSetStatusText("Move Your Vampire");	
	moMoveCmd.Init();
	moMoveCmd.Posn(nX, nY);
	moMoveCmd.SetButtonCels(0,2,3,1);
	moMoveCmd.SetPri(5);
	moMoveCmd.Hide();

	nX = mpoTemplate->lGetValue(TAG_IatX, 0);
	nY = mpoTemplate->lGetValue(TAG_IatY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCat, 0);
	moAttackCmd.vSetPlane(this);
//	moAttackCmd.SetFont(2,3,4,5);
//	moAttackCmd.SetText("Attack");
//	moAttackCmd.vSetTextSize();
//	moAttackCmd.SetWidth(moAttackCmd.nTextWidth());
//	moAttackCmd.SetHeight(moAttackCmd.nTextHeight() );
	moAttackCmd.SetPri(mnPriority + 100);
	moAttackCmd.SetView(nBitmapID);
	moAttackCmd.SetHotkey('a');
	moAttackCmd.vSetStatusLine(&moStatusLine);
	moAttackCmd.vSetStatusText("Attack something");	
	moAttackCmd.Init();
	moAttackCmd.Posn(nX,nY);
	moAttackCmd.SetButtonCels(0,2,3,1);
	moAttackCmd.SetPri(5);
	moAttackCmd.Hide();

	nX = mpoTemplate->lGetValue(TAG_IfeX, 0);
	nY = mpoTemplate->lGetValue(TAG_IfeY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCfe, 0);
	moFeedCmd.vSetPlane(this);
//	moFeedCmd.SetFont(2,3,4,5);
//	moFeedCmd.SetText("Feed");
//	moFeedCmd.vSetTextSize();
//	moFeedCmd.SetWidth(moFeedCmd.nTextWidth());
//	moFeedCmd.SetHeight(moFeedCmd.nTextHeight() );
	moFeedCmd.SetPri(mnPriority + 100);
	moFeedCmd.SetView(nBitmapID);
	moFeedCmd.SetHotkey('f');
	moFeedCmd.vSetStatusLine(&moStatusLine);
	moFeedCmd.vSetStatusText("Feed (Mmmm thirsty...)");	
	moFeedCmd.Init();
	moFeedCmd.Posn(nX,nY);
	moFeedCmd.SetButtonCels(0,2,3,1);
	moFeedCmd.SetPri(5);
	moFeedCmd.Hide();

	nX = mpoTemplate->lGetValue(TAG_IcoX, 0);
	nY = mpoTemplate->lGetValue(TAG_IcoY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCco, 0);
	moVampirize.vSetPlane(this);
//	moVampirize.SetFont(2,3,4,5);
//	moVampirize.SetText("Vampirize");
//	moVampirize.vSetTextSize();
//	moVampirize.SetWidth(moVampirize.nTextWidth());
//	moVampirize.SetHeight(moVampirize.nTextHeight() );
	moVampirize.SetPri(mnPriority + 100);
	moVampirize.SetView(nBitmapID);
	moVampirize.SetHotkey('v');
	moVampirize.vSetStatusLine(&moStatusLine);
	moVampirize.vSetStatusText("Convert to a Vampire");	
	moVampirize.Init();
	moVampirize.Posn(nX,nY);
	moVampirize.SetButtonCels(0,2,3,1);
	moVampirize.SetPri(5);
	moVampirize.Hide();

	nX = mpoTemplate->lGetValue(TAG_ItaX, 0);
	nY = mpoTemplate->lGetValue(TAG_ItaY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCta, 0);
	moTake.vSetPlane(this);
//	moTake.SetFont(2,3,4,5);
//	moTake.SetText("Take");
//	moTake.vSetTextSize();
//	moTake.SetWidth(moTake.nTextWidth());
//	moTake.SetHeight(moTake.nTextHeight() );
	moTake.SetPri(mnPriority + 100);
	moTake.SetView(nBitmapID);
	moTake.SetHotkey('t');
	moTake.vSetStatusLine(&moStatusLine);
	moTake.vSetStatusText("Take an item");	
	moTake.Init();
	moTake.Posn(nX,nY);
	moTake.SetButtonCels(0,2,3,1);
	moTake.SetPri(5);
	moTake.Hide();

	nX = mpoTemplate->lGetValue(TAG_IcaX, 0);
	nY = mpoTemplate->lGetValue(TAG_IcaY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCca, 0);
	moCastCmd.vSetPlane(this);
//	moCastCmd.SetFont(2,3,4,5);
//	moCastCmd.SetText("Cast");
//	moCastCmd.vSetTextSize();
//	moCastCmd.SetWidth(moCastCmd.nTextWidth());
//	moCastCmd.SetHeight(moCastCmd.nTextHeight() );
	moCastCmd.SetPri(mnPriority + 100);
	moCastCmd.SetView(nBitmapID);
	moCastCmd.SetHotkey('c');
	moCastCmd.vSetStatusLine(&moStatusLine);
	moCastCmd.vSetStatusText("Cast Spell");	
	moCastCmd.Init();
	moCastCmd.Posn(nX,nY);
	moCastCmd.SetButtonCels(0,2,3,1);
	moCastCmd.SetPri(5);
	moCastCmd.Hide();

	nX = mpoTemplate->lGetValue(TAG_IguX, 0);
	nY = mpoTemplate->lGetValue(TAG_IguY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCgu, 0);
	moGuardCmd.vSetPlane(this);
//	moGuardCmd.SetFont(2,3,4,5);
//	moGuardCmd.SetText("Guard");
//	moGuardCmd.vSetTextSize();
//	moGuardCmd.SetWidth(moGuardCmd.nTextWidth());
//	moGuardCmd.SetHeight(moGuardCmd.nTextHeight() );
	moGuardCmd.SetPri(mnPriority + 100);
	moGuardCmd.SetView(nBitmapID);
	moGuardCmd.SetHotkey('g');
	moGuardCmd.vSetStatusLine(&moStatusLine);
	moGuardCmd.vSetStatusText("Guard fellow vampire");	
	moGuardCmd.Init();
	moGuardCmd.Posn(nX,nY);
	moGuardCmd.SetButtonCels(0,2,3,1);
	moGuardCmd.SetPri(5);
	moGuardCmd.Hide();

	nX = mpoTemplate->lGetValue(TAG_IpaX, 0);
	nY = mpoTemplate->lGetValue(TAG_IpaY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCpa, 0);
	moPatrolCmd.vSetPlane(this);
//	moPatrolCmd.SetFont(2,3,4,5);
//	moPatrolCmd.SetText("Patrol");
//	moPatrolCmd.vSetTextSize();
//	moPatrolCmd.SetWidth(moPatrolCmd.nTextWidth());
//	moPatrolCmd.SetHeight(moPatrolCmd.nTextHeight() );
	moPatrolCmd.SetPri(mnPriority + 100);
	moPatrolCmd.SetView(nBitmapID);
	moPatrolCmd.SetHotkey('p');
	moPatrolCmd.vSetStatusLine(&moStatusLine);
	moPatrolCmd.vSetStatusText("Patrol around");	
	moPatrolCmd.Init();
	moPatrolCmd.Posn(nX,nY);
	moPatrolCmd.SetButtonCels(0,2,3,1);
	moPatrolCmd.SetPri(5);
	moPatrolCmd.Hide();

	nX = mpoTemplate->lGetValue(TAG_IscX, 0);
	nY = mpoTemplate->lGetValue(TAG_IscY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BCsc, 0);
	moScoutCmd.vSetPlane(this);
//	moScoutCmd.SetFont(2,3,4,5);
//	moScoutCmd.SetText("Scout");
//	moScoutCmd.vSetTextSize();
//	moScoutCmd.SetWidth(moScoutCmd.nTextWidth());
//	moScoutCmd.SetHeight(moScoutCmd.nTextHeight() );
	moScoutCmd.SetPri(mnPriority + 100);
	moScoutCmd.SetView(nBitmapID);
	moScoutCmd.SetHotkey('s');
	moScoutCmd.vSetStatusLine(&moStatusLine);
	moScoutCmd.vSetStatusText("Scout area");	
	moScoutCmd.Init();
	moScoutCmd.Posn(nX,nY);
	moScoutCmd.SetButtonCels(0,2,3,1);
	moScoutCmd.SetPri(5);
	moScoutCmd.Hide();
}

// The 2 display buttons (spell,upgrade) and the cloak/uncloak button and the options button
void InterfacePlane::vInitOtherButtons() {
	int nX, nY, nBitmapID;

	moCloakCmd.vSetPlane(this);
	moCloakCmd.SetFont(2,3,4,5);
	moCloakCmd.SetText("Kloak");
	moCloakCmd.vSetTextSize();
	moCloakCmd.SetWidth(moCloakCmd.nTextWidth());
	moCloakCmd.SetHeight(moCloakCmd.nTextHeight() );
	moCloakCmd.SetPri(mnPriority + 100);
	nX = mpoTemplate->lGetValue(TAG_IclX, 0);
	nY = mpoTemplate->lGetValue(TAG_IclY, 0);
	moCloakCmd.Posn(nX, nY);
//	moCloakCmd.SetView(5001);
	moCloakCmd.SetHotkey('k');
	moCloakCmd.vSetStatusLine(&moStatusLine);
	moCloakCmd.vSetStatusText("Cloak/Uncloak");	
	moCloakCmd.Init();
	moCloakCmd.Hide();

	nX = mpoTemplate->lGetValue(TAG_IcpX, 0);
	nY = mpoTemplate->lGetValue(TAG_IcpY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BIcp, 0);
	moControlCmd.vSetPlane(this);
//	moControlCmd.SetFont(2,3,4,5);
//	moControlCmd.SetText("Ctrl");
//	moControlCmd.vSetTextSize();
//	moControlCmd.SetWidth(moControlCmd.nTextWidth());
//	moControlCmd.SetHeight(moControlCmd.nTextHeight() );
	moControlCmd.Posn(nX, nY);
	moControlCmd.SetView(nBitmapID);
//	moControlCmd.SetHotkey('k');
	moControlCmd.vSetStatusLine(&moStatusLine);
	moControlCmd.vSetStatusText("Control Panel");	
	moControlCmd.Init();
	moControlCmd.Posn(nX,nY);
	moControlCmd.SetButtonCels(0,2,3,1);
	moControlCmd.SetPri(mnPriority + 100);
	moControlCmd.Show();

	nX = mpoTemplate->lGetValue(TAG_ImzX, 0);
	nY = mpoTemplate->lGetValue(TAG_ImzY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BImz, 0);
	moMapZoomCmd.vSetPlane(this);
//	moMapZoomCmd.SetFont(2,3,4,5);
//	moMapZoomCmd.SetText("Zm");
//	moMapZoomCmd.vSetTextSize();
//	moMapZoomCmd.SetWidth(moMapZoomCmd.nTextWidth());
//	moMapZoomCmd.SetHeight(moMapZoomCmd.nTextHeight() );
	moMapZoomCmd.SetView(nBitmapID);
	moMapZoomCmd.SetHotkey(VK_TAB);
	moMapZoomCmd.vSetStatusLine(&moStatusLine);
	moMapZoomCmd.vSetStatusText("Map Zoom");	
	moMapZoomCmd.Init();
	moMapZoomCmd.Posn(nX, nY);
	moMapZoomCmd.SetButtonCels(0,2,3,1);
	moMapZoomCmd.SetPri(mnPriority + 100);
	moMapZoomCmd.Show();

	nX = mpoTemplate->lGetValue(TAG_IdaX, 0);
	nY = mpoTemplate->lGetValue(TAG_IdaY, 0);
	nBitmapID = mpoTemplate->lGetValue(TAG_BIcp, 0);
	moDefAttackCmd.vSetPlane(this);
//	moDefAttackCmd.SetFont(2,3,4,5);
//	moDefAttackCmd.SetText("Ctrl");
//	moDefAttackCmd.vSetTextSize();
//	moDefAttackCmd.SetWidth(moDefAttackCmd.nTextWidth());
//	moDefAttackCmd.SetHeight(moDefAttackCmd.nTextHeight() );
	moDefAttackCmd.Posn(nX, nY);
	moDefAttackCmd.SetView(nBitmapID);
//	moDefAttackCmd.SetHotkey('k');
	moDefAttackCmd.vSetStatusLine(&moStatusLine);
	moDefAttackCmd.vSetStatusText("Default Attack");	
	moDefAttackCmd.Init();
	moDefAttackCmd.Posn(nX,nY);
	moDefAttackCmd.SetButtonCels(0,2,3,1);
	moDefAttackCmd.SetPri(mnPriority + 100);
	moDefAttackCmd.Hide();

}




void InterfacePlane::vClearPortraitArray() {
	for (int i = 0; i < MAX_SELECTION_SIZE; ++i) {
		mapoPortraitArray[i] = NULL;
	}
}

void InterfacePlane::vAddSelection(DrawObj *poObj) {
	//don't add to array if it is already in there somewhere
	if (bInPortraitArray(poObj) == FALSE) {
		for (int i = 0; i < MAX_SELECTION_SIZE; ++i) {
			if (mapoPortraitArray[i] == NULL) {
				mapoPortraitArray[i] = poObj;
				break;
			}
		}
	}
}

void InterfacePlane::vRemoveSelection(DrawObj *poObj) {
	for (int i = 0; i < MAX_SELECTION_SIZE; ++i) {
		if (mapoPortraitArray[i] == poObj) {
			mapoPortraitArray[i] = NULL;
			break;
		}
	}
}

Boolean InterfacePlane::bInPortraitArray(DrawObj *poObj) {
	for (int i = 0; i < MAX_SELECTION_SIZE; ++i) {
		if (mapoPortraitArray[i] == poObj) {
			return TRUE;
		}
	}
	return FALSE;
}


Bitmap * InterfacePlane::GetHighlightBitmap()
{
	if (!mpoHighlightBitmap)
	{
		if (mpoTemplate)
		{
			int nValue = mpoTemplate->lGetValue(TAG_Bhil, 61010);
			mpoHighlightBitmap = (Bitmap*)pApp->pResourceManager->LoadResource(RES_BITMAP, nValue);
		}
	}
	return mpoHighlightBitmap;
}

//returns the array index of poObj in array, -1 if not in array
int InterfacePlane::nArrayIndex(DrawObj *poObj) {
	if (bInPortraitArray(poObj) == TRUE) {
		for (int i = 0; i < MAX_SELECTION_SIZE; ++i) {
			if (mapoPortraitArray[i] == poObj) {
				return i;
				break;
			}
		}
	} 
	return -1;
}

// For swapping inventory items in the dual portrait mode. The destination inventory
// must have at least one slot open. If its open and the oEvent is over the destination,
// the associated unit of the destination is return, else NULL is returned for all other cases.
Unit *InterfacePlane::poSwapItems(sciEvent &oEvent, Unit *poFromUnit)
{
	switch (mePortraitMode) {
	case PD_DUAL:
		{
			DualPortrait *poDestPortrait = NULL;
			
			if (poFromUnit == mpoLeftDualPortrait->poAssociatedUnit())
			{
				//the item is coming from the left portrait, so we're going to try to go
				//into the right
				poDestPortrait = mpoRightDualPortrait;
			
			} else if (poFromUnit == mpoRightDualPortrait->poAssociatedUnit()) {
				//the item is coming from the right portrait, so we're going to try to go
				//into the left 
				poDestPortrait = mpoLeftDualPortrait;
			}

			if (poDestPortrait && poDestPortrait->OnMe(oEvent.x, oEvent.y) && poDestPortrait->nInventorySize() < 3)
			{
				return poDestPortrait->poAssociatedUnit();
			} else {
				return NULL;
			}
			break;
		}
	case PD_LIST:
	case PD_SINGLE:
		return NULL;
		break;
	}
	
	return NULL;
}

void InterfacePlane::vReAdjustScroller()
{
	if (mpoMapScroller)
	{
		// a new map was loaded or created so need to readjust
		mpoMapScroller->vReAdjust();
	}
}

void InterfacePlane::vGameCycle()
{
	mpoMapScroller->vGameCycle();
}
void InterfacePlane::vUpdateScroller()
{
	mpoMapScroller->vForceUpdate();
}

//Returns in nX/nY the starting coords of the button
void InterfacePlane::vButtonStartCoords(int nUpgrade, int &nX, int &nY)
{
	nX = 0;
	nY = 0;
	int nPos = mpoPlayer->nUpgradePosition(nUpgrade);
	
	if (mpoPlayer->nKnownUpgrades() <= 4)
	{
		switch (nPos)
		{
		case 1:
			nX = mpoTemplate->lGetValue(TAG_Ic1X,0);
			nY = mpoTemplate->lGetValue(TAG_Ic1Y,0);
			break;
		case 2:
			nX = mpoTemplate->lGetValue(TAG_Ic2X,0);
			nY = mpoTemplate->lGetValue(TAG_Ic2Y,0);
			break;
		case 3:
			nX = mpoTemplate->lGetValue(TAG_Ic3X,0);
			nY = mpoTemplate->lGetValue(TAG_Ic3Y,0);
			break;
		case 4:
			nX = mpoTemplate->lGetValue(TAG_Ic4X,0);
			nY = mpoTemplate->lGetValue(TAG_Ic4Y,0);
			break;
		}

	} else {
		//5 or more known upgrades
		switch (nPos)
		{
		case 1:
			nX = mpoTemplate->lGetValue(TAG_Iu1X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu1Y,0);
			break;
		case 2:
			nX = mpoTemplate->lGetValue(TAG_Iu2X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu2Y,0);
			break;
		case 3:
			nX = mpoTemplate->lGetValue(TAG_Iu3X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu3Y,0);
			break;
		case 4:
			nX = mpoTemplate->lGetValue(TAG_Iu4X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu4Y,0);
			break;
		case 5:
			nX = mpoTemplate->lGetValue(TAG_Iu5X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu5Y,0);
			break;
		case 6:
			nX = mpoTemplate->lGetValue(TAG_Iu6X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu6Y,0);
			break;
		case 7:
			nX = mpoTemplate->lGetValue(TAG_Iu7X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu7Y,0);
			break;
		case 8:
			nX = mpoTemplate->lGetValue(TAG_Iu8X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu8Y,0);
			break;
		case 9:
			nX = mpoTemplate->lGetValue(TAG_Iu9X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu9Y,0);
			break;
		case 10:
			nX = mpoTemplate->lGetValue(TAG_Iu0X,0);
			nY = mpoTemplate->lGetValue(TAG_Iu0Y,0);
			break;

		}

	}

}

void InterfacePlane::vZoomMap()
{
	mpoMapScroller->vZoom();
}

void InterfacePlane::vSetDefaultAttackBitmap(RefList<DrawObj> *poUnitList)
{
	Boolean bHandToHand = 0;
	Boolean bSpell = 0;

	int nBitmapID = 0;

	//go through selected units and find out all of their default attacks
	//if they're all the same thing then display that(either the HandToHand or appropiate Spell), 
	//else display the 'UNCLEAR' icon
	for (int j = 0; j < poUnitList->GetSize(); ++j) {
		DrawObj *poUnit = poUnitList->GetItem(j);
		if (poUnit->bIsUnit())
		{	
			DEFAULT_ATTACK eDefAtt = ((Unit*)poUnit)->eDefaultAttack();
			switch (eDefAtt)
			{
				case DA_HANDTOHAND:
				{
					if (bSpell) {
						nBitmapID = mpoTemplate->lGetValue(TAG_BIna,0);
						goto done;
					}
					if (!bHandToHand) {
						bHandToHand = TRUE;
						nBitmapID = mpoTemplate->lGetValue(TAG_BIda,0);
					}
					break;
				}
				case DA_SPELL:
				{
					if (bHandToHand) {
						nBitmapID = mpoTemplate->lGetValue(TAG_BIna,0);
						goto done;
					}
					if (!bSpell) {
						bSpell = TRUE;
						Spell *poSpell = game->GetTrueSpell(((Unit*)poUnit)->nCurrentSpell());
						int nID = poSpell->nGetDefAttBitmapID();
						if (nBitmapID != 0 && nID != nBitmapID)
						{
							nBitmapID = mpoTemplate->lGetValue(TAG_BIna,0);
							goto done;
						} else {
							nBitmapID = nID;
						}
					}
					break;
				}
			}
		}
	}

done:
	assert(nBitmapID);
	moDefAttackCmd.SetView(nBitmapID);

}


void InterfacePlane::vSetDefaultAttackBitmap(Unit *poUnit)
{
	int nBitmapID = 0;
	DEFAULT_ATTACK eDefAtt = poUnit->eDefaultAttack();
	switch (eDefAtt)
	{
		case DA_HANDTOHAND:
			nBitmapID = mpoTemplate->lGetValue(TAG_BIda,0);
			break;
		case DA_SPELL:
		{
			Spell *poSpell = game->GetTrueSpell(poUnit->nCurrentSpell());
			nBitmapID = poSpell->nGetDefAttBitmapID();
		}
	}
	assert(nBitmapID);
	moDefAttackCmd.SetView(nBitmapID);
}

void InterfacePlane::vShowPicker(Boolean bShowHandToHand)
{
	if (mpoPicker)
	{
		vHideCommandButtons();
		vHideUpgradeButtons();
		mpoPicker->vShow(bShowHandToHand);
	}
}

void InterfacePlane::vShowButtons()
{
	vShowUpgradeButtons(mpoSelectionList);
	vShowCommandButtons();
}

// poFrom - the unit before it was vampirized
// ptTo   - the newly converted vampire
/*void InterfacePlane::vChangePortraitToVampire(DrawObj *poFrom, DrawObj *poTo) {
	int nNdx = nArrayIndex(poFrom);
	if (nNdx != -1) {
		mapoPortraitArray[nNdx] = poTo;
	}
}
*/

