// MAPPLANE.H -- the the map plane
//
// DJM

#ifndef _mapplane
#define _mapplane

#include "sciplane.h"
#include "mapnode.h"

class MapPlane : public sciPlane {
	RefList<DrawObj> moDrawnList; // list of all objects drawn, for event handling

public:
	GameMap *mpoMap;

	MapPlane();
	~MapPlane();

	virtual void Render(RECT &updateRect);
	
	virtual void Doit();
	Boolean HandleEvent(sciEvent & oEvent);
	void vSetMovement (MapNode *poNode);
	void vAddToDrawnList(DrawObj *poDrawObj) {moDrawnList.AddToEnd(poDrawObj);};
	void vClearDrawnList() {moDrawnList.RemoveAll();}
	void vRemoveFromDrawnList(DrawObj *poDrawObj) { moDrawnList.Remove(poDrawObj); }

	int nMapOrgPixelX() {return mpoMap->nOrgPixelX();}
	int nMapOrgPixelY() {return mpoMap->nOrgPixelY();}
	
	//The check for dragging an item from inventory onto a unit
	//Returns NULL if nX,nY not on any drawn Unit else
	//returns a pointer to the unit that nX,nY is on. 
	Unit * poOnUnit(sciEvent &oEvent);
protected:
	int mnMouseScrollSpeed;
};

#endif