#include "movement.h"

void SequentialProcedure::Add( Object * pNode )
{
	assert(pNode); // no null nodes please
	moWaypoints.AddToEnd(pNode);
}

void SequentialProcedure::ProceedToNext()
{
	int nSize = moWaypoints.GetSize();

	if (nSize == 0) return;

	mnCurrentWaypoint += mnIncrement;

	if (mnCurrentWaypoint == -1)
	{
		mnCurrentWaypoint = 0;
		mnIncrement = 1;
	}
	else if (mnCurrentWaypoint == nSize)
	{
		if (!mbCircular)
		{
			mnCurrentWaypoint = nSize - 1;
			mnIncrement = -1;
		}
		else
		{
			mnCurrentWaypoint = 0;
			mnIncrement = 1;
		}
	}
}
 	
void SequentialProcedure::Get( Object ** pReturnMapNode)
{
	*pReturnMapNode = moWaypoints.GetItem(mnCurrentWaypoint);

	//assert(*pReturnMapNode); 
}
void SequentialProcedureResponsible::Add( Object * pNode )
{
	assert(pNode); // no null nodes please
	moWaypoints.AddToEnd(pNode);
}

void SequentialProcedureResponsible::ProceedToNext()
{
	int nSize = moWaypoints.GetSize();

	if (nSize == 0) return;

	mnCurrentWaypoint += mnIncrement;

	assert(mnCurrentWaypoint <= nSize);

	if (mnCurrentWaypoint == -1)
	{
		mnCurrentWaypoint = 0;
		mnIncrement = 1;
	}
	else if (mnCurrentWaypoint == nSize)
	{
		if (!mbCircular)
		{
			mnCurrentWaypoint = nSize - 1;
			mnIncrement = -1;
		}
		else
		{
			mnCurrentWaypoint = 0;
			mnIncrement = 1;
		}
	}
}
	
void SequentialProcedureResponsible::Get( Object ** pReturnMapNode)
{
	if (moWaypoints.GetSize() > mnCurrentWaypoint)
	{
		*pReturnMapNode = moWaypoints.GetItem(mnCurrentWaypoint);
		
	}
	else
	{
		*pReturnMapNode = NULL;
	}
}


void SequentialCommands::vSaveMap(FILE *file, WORD wVersion)
{
	int nSize = moWaypoints.GetSize();
	int i = 0;

	fwrite(&nSize, sizeof(int), 1, file);

	while (i < nSize)
	{
		Command * poCommand = (Command *)moWaypoints.GetItem(i);
			
		fwrite(&(poCommand->meType), sizeof(COMMAND_TYPE), 1, file);
		fwrite(&(poCommand->mnX), sizeof(int), 1, file);
		fwrite(&(poCommand->mnY), sizeof(int), 1, file);
		i++;
	}
}


void SequentialCommands::vLoadMap(FILE *file, WORD wVersion) 
{
	int nSize = 0;
	int i = 0;

	fread(&nSize, sizeof(int), 1, file);

	Command oCommand;
	while (i<nSize)
	{
		fread(&(oCommand.meType), sizeof(COMMAND_TYPE), 1, file);
		fread(&(oCommand.mnX), sizeof(int), 1, file);
		fread(&(oCommand.mnY), sizeof(int), 1, file);

		Add(&oCommand);
		i++;
	}
}

void SequentialCommands::Add( Command * pObject )
{ 
	assert(pObject);
	Command * pCommand = new Command;
	memcpy(pCommand, pObject, sizeof(Command));
		//*pCommand = *pObject;
	SequentialProcedureResponsible::Add(pCommand); 
}


BOOL SequentialCommands::bAtBeginning()
{ 
	return (mnCurrentWaypoint == 0);
}

