#ifndef _movement_
#define _movement_

#ifndef _os
#include "os.h"
#endif

#ifndef _UNIT_
#include "Unit.h"
#endif

class SequentialProcedure : public Object
{
public:
	SequentialProcedure(Unit& unit):
		moUnitOwner(unit),
		mbCircular(FALSE),
		mnIncrement(1),
		mbClosed(FALSE),
		mnCurrentWaypoint(0)
	{}

	void Add( Object * pObject );
	void ProceedToNext();
	void Get( Object ** pReturnObject);

	virtual ~SequentialProcedure()	{}

protected:
	Unit &				moUnitOwner;				// owner of this Thought
	BOOL				mbCircular;					// circular or end-to-end
	BOOL				mbClosed;
	int					mnCurrentWaypoint;			// current waypoint in list
	RefList<Object>	moWaypoints;				// list of waypoints

private:
	int				mnIncrement;				// for end to end up and down
};

class SequentialProcedureResponsible : public Object
{
public:
	SequentialProcedureResponsible(Unit& unit):
		moUnitOwner(unit),
		mbCircular(FALSE),
		mnIncrement(1),
		mbClosed(FALSE),
		mnCurrentWaypoint(0)
	{}

	void Add( Object * pObject );
	void ProceedToNext();
	void Get( Object ** pReturnObject);

	virtual ~SequentialProcedureResponsible()	{}

protected:
	Unit &				moUnitOwner;				// owner of this Thought
	BOOL				mbCircular;					// circular or end-to-end
	BOOL				mbClosed;
	int					mnCurrentWaypoint;			// current waypoint in list
	List<Object>		moWaypoints;					// list of waypoints

private:
	int				mnIncrement;				// for end to end up and down
};

class SequentialMovement : public SequentialProcedure
{
public:
	SequentialMovement(Unit& unit):SequentialProcedure(unit) 
	{
		// store current position as first waypoint
		Add(moUnitOwner.poNode());
	}
	~SequentialMovement() {}

	void Add( MapNode * pObject ) 
	{ 
		SequentialProcedure::Add(pObject); 
	}

	void Get( MapNode ** pReturnMapNode)
	{
		SequentialProcedure::Get((Object **)pReturnMapNode);
	}
};

// peasants
		// wander
			// move 10 paces towards something
		// desire to go home
		// find places to go


		// MoveTo

		// MoveTo(node)

		// AttemptChat(time)
		// Find peasants with whom to chat
		//		Wait for time and Scan for other people
		//		IfFound, Hail (hi)
		//		IfResponse, Chat (..f.dfjklf ... Vampires! .. fjdjfkl lkdf)
		//			vary the audible content by anxiety

		// Meander()
		// scan for place to move
		//		move there

		// Chat(time)
		// have conversations with another unit
		//		meet at hailed peasant location.  Face one another, stand there
		// and gesture infrequently.  Slight noise.
			
		// incite mobs
		// form mobs

// vampires
		// feed on humans
		// convert humans
		// detect and mark other vampires
			// of lower levels cloaked within respective ranges
			// uncloaked 

class SequentialCommands : public SequentialProcedureResponsible
{
public:
	SequentialCommands(Unit& unit):SequentialProcedureResponsible(unit) {}
	~SequentialCommands() {}

	void Add( Command * pObject ); 

	void Get( Command ** pReturnMapNode)
	{
		SequentialProcedureResponsible::Get((Object **)pReturnMapNode);
	}

	void vSaveMap(FILE *file, WORD wVersion);
	void vLoadMap(FILE *file, WORD wVersion);
	BOOL bAtBeginning();
};



#endif