// OBJECTDB.H -- the game objects database
//
// DJM

#ifndef _OBJECTDB_
#define _OBJECTDB_

#include "scimain.h"
#include "mapnode.h"

class ObjectDB : public Object {
public:
	ObjectDB();

	DrawObj *poGetObject(int nID) {return (DrawObj*)moObjects.GetItem(nID);};
	void vAddObject(DrawObj *poObject);
	void vAddObjectFast(DrawObj *poObject); // don't search for empty slots, just add to end
	void vRemoveObject(DrawObj *poObject);
	void vRemoveObject(int nID);

	int nTotalSlots(void) {return moObjects.GetSize();}
	int nUsedSlots(void) {return nTotalObjects;}

	RefList<DrawObj> *poRawDB(void) {return &moObjects;}

protected:
	RefList<DrawObj>	 moObjects; // list of DrawObjs
	int		nTotalObjects; // total number in DB
};

extern ObjectDB goObjectDB;

#endif
	
