#include "os.h"
#include "polygon.h"

int PointInterior(sciPoint &M, sciPoint *polygon, int n)
	{
	sciPoint N3, P1, P2, P3, P4;
	sciPoint tmp1, tmp2;
	int nextnode, interior = 0;

	P1 = polygon[0];
	P2 = polygon[1];
	nextnode = 3;
	P3 = N3 = polygon[2];
	if (n>3)
		P4 = polygon[3];
	else
		P4 = polygon[0];
	while (TRUE)
		{
		// If M is interior to some line segment of
		// the polygon consider it as interior.
		if (
			(
				(
					(P1.y <= M.y)	&&
					(M.y <= P2.y) 
				)
			||
				(
					(P2.y <= M.y)	&&
					(M.y <= P1.y)
				)
			)
		&&
			(
				(
					(P1.x <= M.x)	&&
					(M.x <= P2.x) 
				)
			||
				(
					(P2.x <= M.x)	&&
					(M.x <= P1.x)
				)
			)
		)

		{
		//tmp1 = M - P1;
		tmp1.x = M.x - P1.x;
		tmp1.y = M.y - P1.y;
		//tmp2 = M - P2;
		tmp2.x = M.x - tmp2.x;
		tmp2.y = M.y - tmp2.y;
		//if ((tmp1^tmp2) == 0)
		if (((tmp1.x * tmp2.y) - (tmp1.y * tmp2.x)) == 0)
			return TRUE;
		}

		// The algorithm counts the number of intersections with the
		// given polygon going from M in the negative x direction.
		// If this number is odd M must be interior to the polygon.

		// If M is above or below P1-P2 then there can't be 
		// an intersection of the ray from M in the negative x
		// direction with the line segment P1-P2.
		if (
			(
				(P1.y < M.y)	&&
				(M.y < P2.y) 
			)
		||
			(
				(P2.y < M.y)	&&
				(M.y < P1.y)
			)
		)

		{
		// If P1-P2 or P2-P1 is chosen so that the y delta is 
		// positive and this vector is crossed with the vector
		// P1-M then the z component is positive if M lies on
		// the negative side of P1-P2 and negative if M lies
		// on the positive side of P1-P2.
		//tmp1 = P2 - P1;
		tmp1.x = P2.x - P1.x;
		tmp1.y = P2.y - P1.y;
		if (tmp1.y < 0)
			{
			//tmp1 = -tmp1;
			tmp1.x = -tmp1.x;
			tmp1.y = -tmp1.y;
			}
		//tmp2 = M - P1;
		tmp2.x = M.x - P1.x;
		tmp2.y = M.y - P1.y;
		//if ((tmp1^tmp2) > 0)
		if (((tmp1.x * tmp2.y) - (tmp1.y * tmp2.x)) > 0)
			++interior;
		}
		else
			{
			// If the ray in the negative x direction from M passes
			// through the point P2 then one must look at the next
			// segment of the polygon which is not parallel with the
			// x axis in order to determine if the is an intersection
			// at P2. Note that consecutive line segment are not allowed
			// to be parallel in a given polygon.

			if ((P2.y == M.y) && (M.x < P2.x))
				{
            /* types of intersections checked here:

               *           *       *    *             *            *
                *           *     *      *             *          *
                 *           *   *        *             *        *
                  *           * *          *             *      *
            <------*-----------*------------*****---------******----------M
                   *                             *
                   *                              *
                   *                               *           
                   *                                *
                   *                                 *

                  intersection?
                  yes          no             yes           no          
            */



				if (P3.y != P2.y)
					{
					if ((int)(P2.y-P1.y)*(int)(P3.y-P2.y) > 0) ++interior;
					}
				else
					{
					if ((int)(P2.y-P1.y)*(int)(P4.y-P3.y) > 0) ++interior;
					}
				}
			}
		P1 = P2;
		P2 = P3;
		P3 = P4;

		// See if there are any more line segments
		// in the polygon to be tested.
		if ((P3.x == N3.x) && (P3.y == N3.y)) break;

		P4 = polygon[(++nextnode) % n];
		}

	if (interior & 1)
		return TRUE;
	else
		return FALSE;
	}
