#ifndef _resource
#define _resource

#include <stdio.h>
#include "object.h"

class UniHandle;
class ResourceManager;

typedef enum
	{
	RES_NONE = 0,
	RES_BITMAP,
	RES_SOUND,
	RES_CW,
	RES_PALETTE,
	RES_MP,
	RES_SYNC,
	RES_ANMA,
	RES_FONT,
	RES_BETTABLE,
	RES_PLAYER,
	RES_POKERPLAYER,
	RES_BLACKJACKPLAYER,
	RES_MSK1,
	RES_PNG,
	RES_VIEWBITMAP,
	RES_MAPOBJ,
	RES_MAP,
	RES_TEMPLATE,
	RES_NUM_OF_TYPES,
	} RESOURCE_TYPES;

class Resource : public Object
	{
	public:
		Resource(RESOURCE_TYPES newType, int newResourceID, ResourceManager *newResourceManager);
		~Resource();
		int GetSize();
		virtual BYTE *GetData();
		void vWriteFile();

		RESOURCE_TYPES type;
		int resourceID;

	protected:
		void ReadPRF();
		void ReadFile();
		virtual void vWriteData(FILE *pFile);

		BOOL bDataChanged;

		BYTE *data;
		int numOfBytes;
		ResourceManager *resourceManager;
	};

#endif	// _resource
