#include "os.h"
#include "scicursr.h"
#include "scimotn.h"
#include "sciplane.h"
#include "app.h"
#include "window.h"

extern Application *pApp;

sciCursor::sciCursor()
	{
	priority = 999;
	SetHotspot(0, 0);
	}

sciCursor::~sciCursor()
	{
	}

void sciCursor::Init()
	{
	POINT ptTmp;

	// Find where the Windows cursor is.
	GetCursorPos(&ptTmp);
	ScreenToClient(plane->window->hWnd, &ptTmp);
	Posn(ptTmp.x, ptTmp.y);

	sciView::Init();
	}

Boolean sciCursor::HandleEvent(sciEvent &event)
	{
	int newX, newY;

	if (event.type == MOUSE_MOVE)
		{
		newX = event.x - hotspotX;
		newY = event.y - hotspotY;
		if ((event.x >= 640) || (event.y >= 480) || (event.x < 0) || (event.y < 0))
			{
			newX = 640;
			newY = 480;
			}
		//if (!IsNotHidden())
		//	{
		//	event.claimed = TRUE;
		//	}
		if ((GetX() != newX) || (GetY() != newY))
			Posn(newX, newY);
		}
	return FALSE;
	}

void sciCursor::SetHotspot(int x, int y)
	{
	hotspotX = x;
	hotspotY = y;
	}

void sciCursor::Show(BOOL newPermanent)
	{
	if (newPermanent)
		{
		permanentShown = TRUE;
		permanentHidden = FALSE;
		}
	if (permanentHidden)
		return;
	sciActor::Show();
	SetClassLong(plane->window->hWnd, GCL_HCURSOR,
		(LONG) plane->window->hHandCursor);
	}

void sciCursor::Hide(BOOL newPermanent)
	{
	if (newPermanent)
		{
		permanentHidden = TRUE;
		permanentShown = FALSE;
		}
//	if (permanentShown)
//		return;
	sciActor::Hide();
	SetClassLong(plane->window->hWnd, GCL_HCURSOR,
		(LONG) plane->window->hNormalCursor);
	}
