#ifndef _scicycle
#define _scicycle

#include "sciobj.h"

class sciProp;
class sciScript;

#define CYCLEDIR_FORWARD 1
#define CYCLEDIR_REVERSE -1

class sciCycle : public sciObject
	{
	public:
		sciCycle(sciScript *newCaller = NULL);
		~sciCycle();
		virtual void Init(sciProp *newClient);
		int NextCel();
		void CycleDone();
		virtual void Doit();

	protected:
		sciProp *client;
		sciScript *caller;
		int cycleDir;
		int cycleCnt;
		int clientLastCel;
		Boolean inMotion;
	};

class sciForward : public sciCycle
	{
	public:
		sciForward();
		~sciForward();
		void Doit();
		void CycleDone();
	};

class sciReverse : public sciCycle
	{
	public:
		sciReverse();
		~sciReverse();
		void Doit();
		void CycleDone();
	};

class sciCycleTo : public sciCycle
	{
	public:
		sciCycleTo(sciScript *newCaller = NULL);
		~sciCycleTo();
		void Doit();
	protected:
		int endCel;
	};

class sciBegLoop : public sciCycleTo
	{
	public:
		sciBegLoop(sciScript *newCaller = NULL);
		virtual void Init(sciProp *newClient);
	};

class sciEndLoop : public sciCycleTo
	{
	public:
		sciEndLoop(sciScript *newCaller = NULL);
		virtual void Init(sciProp *newClient);
	};

class sciOscillate : public sciCycle
	{
	public:
		sciOscillate();
		~sciOscillate();
		void Doit();
		void CycleDone();
	};

#endif // _scicycle
