#ifndef _scigame
#define _scigame

#include "sciobj.h"

class sciEvent;
class sciScript;
class sciRoom;
class sciSound;
class DebugHandler;

class sciGame : public sciObject
	{
	public:
		sciGame();
		~sciGame();
		Boolean HandleEvent(sciEvent &event);
		int GetTime();	// GetTime won't change during an animation cycle.
		int GetTrueTime();
		void Play();
		void QuitGame(Boolean iReallyMeanIt = FALSE);
		void Init();
		void Doit();
		void SetScript(sciScript *newScript);
		void SetNextRoom(int newRoomNum);
		int GetCurrentRoomNum();
		Boolean IsDone();
		void SetGameName(char *);

		void vSetPause(BOOL bPause) {mbPaused = bPause;}
		BOOL bPaused(void) {return mbPaused;}

		virtual void vGameTick(void) {return;}; // give the subclass an opportunity

		sciRoom *curRoom;
		sciSound *sound1, *sound2;

	protected:
		void LoadRoom(int roomNum);
		virtual void LoadTheRoom(int roomNum);
		DebugHandler * mpoDebug;

		int time;
		Boolean quit;
		sciScript *script;
		int nextRoomNum;
		int prevRoomNum;
		int curRoomNum;

		BOOL mbPaused;
		int mnPauseTime;
	};

#endif // _scigame
