#ifndef _scitext
#define _scitext

#include "sciview.h"

typedef struct {
	WORD top;
	WORD left;
	WORD bottom;
	WORD right;
	} characters;

typedef struct {
	WORD bitmapID;
	WORD shadowWidth;
	WORD shadowHeight;
	WORD characterSpacing;
	WORD lineSpacing;
	WORD numChars;
	characters theChars[256];
	} FONT;

class Bitmap;

enum
	{
	JUST_LEFT		= 0x01,
	JUST_RIGHT		= 0x02,
	JUST_TOP		= 0x04,
	JUST_BOTTOM		= 0x08,
	JUST_VERTICAL	= 0x10,
	JUST_HORIZONTAL	= 0x20,
	};

class sciText : public sciView
	{
	public:
		sciText();
		~sciText();
		void SetFont(int newFont);
		void SetText(char *newText);
		void SetWidth(int newWidth);
		void SetHeight(int newHeight);
		void SetBackgroundColor(BYTE newColor);
		void SetJust(int newJust);
		void vSetPlane(sciPlane *poPlane) {plane = poPlane;}
		void vRefresh(void);
		void vSetSize(void);
		void vGetSize(POINT &oPoint, int nNumCharacters = NULL);
		char* GetText();
		int GetCaretX();
		int GetCaretY();
		void Init();
		void vDraw();
		int nHeight() {return height;}
		int nWidth()  {return width;}
		int nCharHeight(char cChar);	//returns the height of a given character
		int nCharWidth(char cChar);		//returns the width of a given character

	protected:
		virtual void RenderText();
		void CalculateSize(char *theText, int *theWidth, int *theHeight);

		BYTE backgroundColor;
		int width, height;
		char *text;
		FONT fontResource;
		Bitmap *fontBitmap;
		int just;
		int caretX, caretY;
		int fontNumber;
	};

#endif // _scitext
