#ifndef _sigs
#define _sigs

#include "sciobj.h"
//#include "scilist.h"

class Message : public sciObject
	{
	public:
		int from;
		int type;
		BYTE *data;
	};

#define MESSAGE_TYPE int

#define FIRST_BLACKJACK_MESSAGE		0x01	// For compatibility with Hoyle Blackjack
#define	MENU_MESSAGE				0x01
#define	DECK_MESSAGE				0x02
#define	SETPLAYER_MESSAGE			0x03
#define	INSURANCE_MESSAGE			0x04
#define	IQUIT_MESSAGE				0x05
#define	MYVERSION_MESSAGE			0x06
#define	USINGBETA_MESSAGE			0x07
#define	CHAT_MESSAGE				0x08
#define LAST_BLACKJACK_MESSAGE		0x08

#define FIRST_QUEUED_MESSAGE		0x10	// Queue up these messages.
#define LAST_QUEUED_MESSAGE			0x10

#define FIRST_NON_QUEUED_MESSAGE	0x80	// Don't queue up these messages.
#define PLAYSOUND_MESSAGE			0x80
//#define CHAT_MESSAGE				0x81
#define LAST_NON_QUEUED_MESSAGE		0x81

typedef struct
	{
	int message;
	} MENU_STRUCT;

typedef struct
	{
	int timeSeed;
	int numDecks;
	} DECK_STRUCT;

typedef struct
	{
	char text[32];
	} MYVERSION_STRUCT;

typedef enum
	{
	DISCONNECTED,
	IN_GP,
	IN_GAME,
	} GP_CONNECT_STATUS;

#define MAX_NUM_PLAYERS 8

typedef struct
	{
	char name[32];
	char version[32];
	} NETWORK_PLAYER_INFO;

class SIGS : public sciObject
	{
	public:
		SIGS(char *gpName);
		~SIGS();
		void Send(MESSAGE_TYPE messageType, char *buffer, int bufferLen);
		void Pump();
		void HoldMessages(Boolean hold);
		GP_CONNECT_STATUS Status();
		virtual void HandleMyVersion(int playerNum, MYVERSION_STRUCT *myVersion);

		int numPlayers;
		int playerNum;
		int playerToListenTo;
		NETWORK_PLAYER_INFO networkPlayerInfo[MAX_NUM_PLAYERS];

	protected:
		void FreeSIGS();
		void CheckForAMessage();

		// For pre-defined messages.
		void ProcessAMessage(Message *message);

		// For additional messages.
		virtual void ProcessTheMessage(Message *message) = 0;

		void CheckPlayerStatusNow(int i);
		Boolean NetworkOK();
		virtual void RemovePlayer(int i);

		Boolean holdMessages;
		Boolean networkOK;
		RefList<Message> listOfMessages;
		HINSTANCE sigsDLL;
		HINSTANCE validateDLL;
		int sendMessageNumber;
		int receiveMessageNumber;
		int livePlayers[MAX_NUM_PLAYERS];
		int numLivePlayers;
		Boolean firstTimeInGame;
	};

#endif // _sigs
