#ifndef _SoundManager
#define _SoundManager

#ifndef _RESMAN_
#include "resman.h"
#endif

#ifndef _sciscrip
#include "sciscrip.h"
#endif


#define MAXPLAYLISTITEMS 32

// HIGHEST = 32768   LOWEST = 0
#define SOUNDPRIORITY_BACKGROUNDMUSIC	32000
#define SOUNDPRIORITY_AMBIENTSOUNDS		31000
#define SOUNDPRIORITY_EXPLOSIONS		30000
#define SOUNDPRIORITY_UNITSOUNDS		29000


typedef enum 
{
	STATUS_NOWCALLPREINIT ,
	STATUS_NOWCALLINIT,
	STATUS_READY,
	STATUS_SHUTDOWN
} STATUS_SMDW;


extern int globalAvailVoices;

class SoundManager
{
public:
	SoundManager():eStatus(STATUS_NOWCALLPREINIT),resourceManager(NULL) {}
	~SoundManager() 
	{ 
		assert(eStatus == STATUS_SHUTDOWN); 
	}

	virtual void PreInit() = 0;		// determine settings
	virtual void Init(BOOL * bOkay) = 0;		// initialize the sound device

	//virtual void StopAll() = 0;
	virtual void ShutDown() = 0;
protected:
	STATUS_SMDW eStatus;
	ResourceManager * resourceManager;
};


#endif
