#ifndef _SPELL_H_
#define _SPELL_H_

#ifndef _MISSILE_H_
#include "missile.h"
#endif

typedef enum
{
	TARGETTYPE_NODE,
	TARGETTYPE_UNIT,
	TARGETTYPE_ORIGIN,
} TYPE_TARGETTYPE;

#define MAXSPELLPARAMCOUNT 5

class Spell : public Object
{
public:
	Spell(Template & oClanTemplate);
	~Spell() {}

	BOOL bNoTargetNeeded();
	SPELL_TYPE GetSpellType();
	UINT GetRange(Unit * poUnit);
	float GetDamage(Unit * poUnit);
	int GetSpeed() { return mnSpeed; }
	float GetCost();
	UINT GetRequiredLevel();
	void CastFromUnit(Unit * poSourceUnit, Unit * poTargetUnit, MapNode * poTargetNode);
	float GetAdjustedSpellCost(Vampire * poVampire);
	int GetDamageRange(Unit * poUnit);
	int nGetPickerBitmapID() {return mpoTemplate->lGetValue(TAG_BPsp,0);}
	int nGetDefAttBitmapID() {return mpoTemplate->lGetValue(TAG_BIda,0);} //returns default attack bitmap ID
	int nTemplateID(void) {return mpoTemplate ? mpoTemplate->resourceID : 0;}
	const char *GetName() {return mpoTemplate->strGetString(TAG_NAME, "Unknown");}
	long lCelCastDelay();
	UINT GetCastResetAfterSpell();
	BOOL bIsAttackUnitSpell();
protected:
	UINT GetDurationCycles();
	Template * mpoTemplate;
	SPELL_TYPE meSpellType;
	double mdRangeA;
	double mdRangeB;
	double mdRangeC;
	float mfRequiredPower;
	int mnRequiredLevel;
	BOOL mbWhileCloaked;
	double mdTimeBase;
	double mdMultiplierLevel;
	double mdMultiplierTimeToCoverDistance;
	int mnSpeed;
	TYPE_TARGETTYPE meTargetType;
	double dParam[MAXSPELLPARAMCOUNT];

	Unit * mpoSourceUnit;
	Unit * mpoTargetUnit;
	MapNode * mpoTargetNode;
	
protected:
	void Cast();
	void Cast_DeathRain();
	void Cast_DoomSpiral();
	void Cast_CallTheSun();
	void Cast_LightningBolt();
	void Cast_Necromance();
	void Cast_VeilOfMist();
	void Cast_BrainWorm();
	void Cast_Phantoms();
	void Cast_MindCloud();
	void Cast_EyeOfTheDragon();
	void Cast_CallFog();
	void Cast_Swap();
	void Cast_Call();
	void Cast_DeathFromAbove();
	void Cast_DisperseMob();
	void Cast_ForceLeech();
	void Cast_Invisibility();
	void Cast_GhostTouch();
};

#endif