// SPLASH.H -- win/lose/opening screens for the milestone the inventory plane for single or dual portraits
//
// TW

#include "scimain.h"
#include "splash.h"
#include "game.h"
#include "rooms.h"

extern Palette *spoPal;

OpeningScreen::OpeningScreen() : sciPlane(pApp->pWindow, TRUE, 5000)
{
	vSetRect(0,0, 640, 480);
	delete spoPal;
	spoPal = new Palette(1);
	spoPal->ActivatePalette();
	delete spoPal;
	spoPal = new Palette(150);
	spoPal->ActivatePalette();
	SetPic(150);
}

OpeningScreen::~OpeningScreen()
{
	SetPic(153);
	Render(mrClip);
	delete spoPal;
	spoPal = new Palette(1);
	spoPal->ActivatePalette();
	delete spoPal;
	spoPal = new Palette(100);
	spoPal->ActivatePalette();
}


Boolean OpeningScreen::HandleEvent(sciEvent & oEvent) {
	//vDebugOut ("type:%d\n", oEvent.type);
	switch (oEvent.type)
	{
	case KEY_CHAR:
	case KEY_PRESS:
	case MOUSE_DOWN:
		oEvent.claimed = TRUE;
		delete this;
		delete game->curRoom;
		game->curRoom = NULL;
		/*game->vSetupGame();
		*/
		//game->QuitGame(TRUE);
		break;
	}

	return (oEvent.claimed);
}







WinScreen::WinScreen() : sciPlane(pApp->pWindow, TRUE, 5000)
{
	game->vSetPause(TRUE);
	vSetRect(0,0, 640, 480);
	delete spoPal;
	spoPal = new Palette(1);
	spoPal->ActivatePalette();
	delete spoPal;
	spoPal = new Palette(151);
	spoPal->ActivatePalette();
	SetPic(151);
}

WinScreen::~WinScreen()
{
	delete spoPal;
	spoPal = new Palette(1);
	spoPal->ActivatePalette();
	delete spoPal;
	spoPal = new Palette(100);
	spoPal->ActivatePalette();
	pApp->pWindow->Erase(mrClip);
}


Boolean WinScreen::HandleEvent(sciEvent & oEvent) {
	static int static_nClicked = 0;
	switch (oEvent.type)
	{
	case KEY_CHAR:
	case KEY_PRESS:
	case MOUSE_DOWN:
		oEvent.claimed = TRUE;
		static_nClicked++;
		if (static_nClicked == 3)
		{
			delete this;
			game->QuitGame(TRUE);
		}
		break;
	}

	return (oEvent.claimed);
}








LoseScreen::LoseScreen() : sciPlane(pApp->pWindow, TRUE, 5000)
{
	game->vSetPause(TRUE);
	vSetRect(0,0, 640, 480);
	delete spoPal;
	spoPal = new Palette(1);
	spoPal->ActivatePalette();
	delete spoPal;
	spoPal = new Palette(152);
	spoPal->ActivatePalette();
	SetPic(152);
}

LoseScreen::~LoseScreen()
{
	delete spoPal;
	spoPal = new Palette(1);
	spoPal->ActivatePalette();
	delete spoPal;
	spoPal = new Palette(100);
	spoPal->ActivatePalette();
	pApp->pWindow->Erase(mrClip);
}

Boolean LoseScreen::HandleEvent(sciEvent & oEvent) {
	static int static_nClicked = 0;
	switch (oEvent.type)
	{
	case KEY_CHAR:
	case KEY_PRESS:
	case MOUSE_DOWN:
		oEvent.claimed = TRUE;
		static_nClicked++;
		if (static_nClicked == 3)
		{
			delete this;
			game->QuitGame(TRUE);
		}
		break;
	}

	return (oEvent.claimed);
}


