#ifndef _vapp
#define _vapp

#include "object.h"
#include "randgen.h"
#include "framebuf.h"

class Sounder;
class Timer;
class Window;
class Palette;
class PRF;
class ResourceManager;
class sciPlane;
class IniFile;
class Random;
class SoundManagerDirectSound;

template <class T> class List;

class VApplication : public Object
	{
	public:
		VApplication();
		virtual ~VApplication();
		virtual int Run();
		virtual void Idle();
		virtual void Exit();
		void PurgeResources(int bytesCanUse = -1);

		FrameBuffer *poFrameBuf(void) {return mpoFrameBuf;}

		//SoundManagerDiamondWare * pSoundManager;
		SoundManagerDirectSound * pSoundManager;
		Sounder *pSounder;
		Timer *pTimer;
		Window *pWindow;
		BOOL bDone;
		Palette *pCurrentPalette;
		ResourceManager *pResourceManager;
		List<ResourceManager> *listOfResourceManagers;
		IniFile *pIniFile;
		//Random *randomGenerator;
		RandomGenerator oLocalRandom;  // for purely local randomness
		RandomGenerator oGlobalRandom; // for stuff that must remail synched with other network players

	protected:
		int iReturnResult;

		FrameBuffer *mpoFrameBuf;
	};

#endif	// _vapplicat
