#ifndef _viewbmp
#define _viewbmp

#include "bitmap.h"
#include "texture.h"

class ViewBitmap : public Bitmap
	{
	public:
		ViewBitmap(int iResourceID, ResourceManager *newResourceManager = NULL, BOOL activatePalette = FALSE);
		~ViewBitmap();
		virtual void vDrawToFrame(FrameBuffer * pFrameBuf, POINT & tDest, RECT & rcSource, BYTE jAlpha = 255, COLOR16 wRemapColor = 0, BYTE jRemapAmount = 0, WORD *pwPalette = NULL);
		void SetCel(int theCel);
		void SetLoop(int theLoop);
		int GetNumLoops();
		int GetNumCels();
		int nGetCel();
		int nGetLoop();
		void vIncrementCel();
		void vDecrementCel();
		void vIncrementLoop();
		void vDecrementLoop();
		short nGetOriginX(int nLoop = 0, int nCel = 0) {return loops[nLoop].cels[nCel].xOrigin;};
		short nGetOriginY(int nLoop = 0, int nCel = 0) {return loops[nLoop].cels[nCel].yOrigin;};
		void vSetOriginPoint(short nNewX, short nNewY, int nLoop = 0, int nCel = 0);
		virtual void vMoveAllOrigins(int nDeltaX, int nDeltaY);
		WORD ColorOfPoint(POINT point);

	protected:
		virtual void CopyRectangle(BYTE *pDestPixels, BYTE *pSourcePixels,
				WORD wDestX, WORD wDestY, WORD wSourceX, WORD wSourceY,
				WORD wBytesToCopy, WORD wRowsToCopy, WORD wDestWidthInBytes, WORD wSourceWidthInBytes,
				BOOL bTransparent, BOOL bFlip);
		void ReadCel(int theLoop, int theCel);
		void ReadLoop(int theLoop);

		BYTE	**rows;
		short	numLoops;
		LOOP	*loops;
		int		loop;
		int		cel;
		BYTE	*stuff;
	};

inline void ViewBitmap::SetCel(int theCel)
{
	//int theLoop;

	if (cel == theCel) {
		return;
	}
	
	//if theCel is greater than the number of cels, set to 0
	if (theCel >= loops[loop].numCels)
		theCel = 0;

	cel = theCel;

	if (loops[loop].numCels) {
		//theLoop = GetNumLoops() - loop - 1;
		//theCel = GetNumCels() - cel - 1;
		rows = loops[loop].cels[cel].rows;
		wWidth = loops[loop].cels[cel].width;
		wHeight = loops[loop].cels[cel].height;
		//wWidthInBytes = wWidth + 3 - ((wWidth - 1) % 4);

		nOriginX = loops[loop].cels[cel].xOrigin;
		nOriginY = loops[loop].cels[cel].yOrigin;
	} else {
		rows = NULL;
		wWidth = 0;
		wHeight = 0;
		//wWidthInBytes = wWidth + 3 - ((wWidth - 1) % 4);

		nOriginX = 0;
		nOriginY = 0;
	}
}


inline void ViewBitmap::SetLoop(int theLoop)
{
	//int theCel;
	if (loop == theLoop) {
		return;
	}

	//if theLoop is greater than the number of loops, set it to 0
	if (theLoop >= numLoops)
	{
		theLoop = 0;
	}

	loop = theLoop;

	if (cel >= GetNumCels())
	{
		cel =0;
	}

	//theLoop = GetNumLoops() - loop - 1;
	//theCel = GetNumCels() - cel - 1;
	if (loops[loop].numCels) {
		rows = loops[loop].cels[cel].rows;
		wWidth = loops[loop].cels[cel].width;
		wHeight = loops[loop].cels[cel].height;
		//wWidthInBytes = wWidth + 3 - ((wWidth - 1) % 4);

		nOriginX = loops[loop].cels[cel].xOrigin;
		nOriginY = loops[loop].cels[cel].yOrigin;
	} else {
		rows = NULL;
		wWidth = 0;
		wHeight = 0;
		nOriginX = 0;
		nOriginY = 0;
	}

}


#endif // _viewbmp
