#include "os.h"

#include "vsound.h"
#include "app.h"
#include "unihand.h"
#include "resman.h"

extern Application *pApp;

VSound::VSound(int newResourceID, ResourceManager *newResourceManager)
	: Resource(RES_SOUND, newResourceID, newResourceManager)
	{
	wfFormat = WF_NONE;
	wSamplesPerSec = 0;
	dwNumOfSamples = 0;
	pSamples = NULL;
	loop = 0;
	ZeroMemory(&wfFormatEx, sizeof(WAVEFORMATEX));
	}

VSound::~VSound()
	{
	if (pSamples)
		delete pSamples;
	}

void VSound::Free()
	{
	resourceManager->FreeResource(this);
	}

BYTE *VSound::GetData()
	{
	if (!pSamples)
		return data;
	return (BYTE*)pSamples;
	}
