#include "os.h"

#include "vsounder.h"
#include "dsstream.h"
#include "sound.h"
#include "app.h"
#include "inifile.h"
#include "scigame.h"
#include "resman.h"
#include "game.h"

#include <string.h>

extern Application *pApp;

VSounder::VSounder()
	{
	char buffer[16];

	playingSound = NULL;
	pApp->pIniFile->ReadString("Sound", "On", buffer, sizeof(buffer));
	if (stricmp(buffer, "On"))
		playSounds = FALSE;
	else
		playSounds = TRUE;
	}

VSounder::~VSounder()
	{
	}

int VSounder::Play(Sound *pSound)
	{
	if (!playSounds)
		return 0;
	EndSound();

	playingSound = pSound;
	deleteSound = FALSE;
	PlayItNow();
	if (playingSound)
		return playingSound->itsEndTime - game->GetTrueTime();
	else
		return 0;
	}

int VSounder::Play(int resourceID, ResourceManager *resourceManager, int newLoop)
	{
	Sound *newSound;

	if (!playSounds)
		return 0;

	if (resourceID == 0)
		return 0;

	if (resourceManager == NULL)
		resourceManager = pApp->pResourceManager;
	newSound = (Sound*)resourceManager->LoadResource(RES_SOUND, resourceID);
	if (newSound && (newSound->wfFormat != WF_NONE))
		{
		EndSound();
		deleteSound = TRUE;
		playingSound = newSound;
		playingSound->loop = newLoop;
		PlayItNow();
		if (playingSound)
			return playingSound->itsEndTime - game->GetTrueTime();
		else
			return 0;
		}
	else
		{
		if (newSound)
			resourceManager->FreeResource(newSound);
		return 0;
		}
    }

void VSounder::EndSoundAfterCompletion()
	{
	while (IsSoundPlaying())
		game->Doit();
	EndSound();
	}

BOOL VSounder::IsSoundPlaying()
	{
	if (playingSound != NULL)
		{
		if ((playingSound->itsEndTime == -1) || (playingSound->itsEndTime >= game->GetTrueTime()))
			return TRUE;
		}
	return FALSE;
	}

